warning('off','all')
%%%%%%%%%%%%%%% Import data sets %%%%%%%%%%%%%%%

Norwegian_data_set = table2array(readtable("Data\new_cases_Norway.csv"));
global_data_set = table2array(readtable("Data\new_cases_global.csv"));

% Transform to log scale imediately
ts = log(max(0.1, Norwegian_data_set));
ts_global = log(max(0.1, global_data_set));

%%%%% General dictionary: %%%%%

% endpoint: last index included as training data

% len_train: amount of training data 

% days_ahead: length of forecast ensuing endpoint

% With_observed: predictioon scheme 1

% no_observed: prediction scheme 2

%%%%%%%%%%%%%%%%%%%%%%%




% Collecting predictions from CNN-LSTM model from Python

%%%%%%%%%%%%%%%%%%%% Gather Global Forecasts %%%%%%%%%%%%%%%%%%%%

loss_func = table2array(readtable(...
    "Predictions\mean_loss_on_original_test_data.csv"));

% global 28 day forecast with prediction scheme 1
glob_test_preds_28_days_ahead_from_100_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_100_with_50_train_data.csv'));
glob_test_preds_28_days_ahead_from_100_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_100_with_100_train_data.csv'));

glob_test_preds_28_days_ahead_from_196_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_196_with_50_train_data.csv'));
glob_test_preds_28_days_ahead_from_196_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_196_with_100_train_data.csv'));
glob_test_preds_28_days_ahead_from_196_with_196_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_196_with_196_train_data.csv'));

glob_test_preds_28_days_ahead_from_300_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_300_with_50_train_data.csv'));
glob_test_preds_28_days_ahead_from_300_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_300_with_100_train_data.csv'));
glob_test_preds_28_days_ahead_from_300_with_300_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_300_with_300_train_data.csv'));

glob_test_preds_28_days_ahead_from_500_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_500_with_50_train_data.csv'));
glob_test_preds_28_days_ahead_from_500_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_500_with_100_train_data.csv'));
glob_test_preds_28_days_ahead_from_500_with_500_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_500_with_500_train_data.csv'));

glob_test_preds_28_days_ahead_from_743_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_500_with_500_train_data.csv'));
glob_test_preds_28_days_ahead_from_743_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_743_with_100_train_data.csv'));
glob_test_preds_28_days_ahead_from_743_with_743_train_data = ...
    table2array(readtable(...
    'Predictions\glob_test_preds_28_days_ahead_from_743_with_743_train_data.csv'));


% global seven and 28 day forecasts with prediction scheme 2
glob_preds_28_days_ahead_from_100_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_100_with_50_train_data.csv'));
glob_preds_7_days_ahead_from_100_with_50_train_data = ...
    glob_preds_28_days_ahead_from_100_with_50_train_data(:, 1:7);
glob_preds_28_days_ahead_from_100_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_100_with_100_train_data.csv'));
glob_preds_7_days_ahead_from_100_with_100_train_data = ...
    glob_preds_28_days_ahead_from_100_with_100_train_data(:, 1:7);

glob_preds_28_days_ahead_from_196_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_196_with_50_train_data.csv'));
glob_preds_7_days_ahead_from_196_with_50_train_data = ...
    glob_preds_28_days_ahead_from_196_with_50_train_data(:, 1:7);
glob_preds_28_days_ahead_from_196_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_196_with_100_train_data.csv'));
glob_preds_7_days_ahead_from_196_with_100_train_data = ...
    glob_preds_28_days_ahead_from_196_with_100_train_data(:, 1:7);
glob_preds_28_days_ahead_from_196_with_196_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_196_with_196_train_data.csv'));
glob_preds_7_days_ahead_from_196_with_196_train_data = ...
    glob_preds_28_days_ahead_from_196_with_196_train_data(:, 1:7);

glob_preds_28_days_ahead_from_300_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_300_with_50_train_data.csv'));
glob_preds_7_days_ahead_from_300_with_50_train_data = ...
    glob_preds_28_days_ahead_from_300_with_50_train_data(:, 1:7);
glob_preds_28_days_ahead_from_300_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_300_with_100_train_data.csv'));
glob_preds_7_days_ahead_from_300_with_100_train_data = ...
    glob_preds_28_days_ahead_from_300_with_100_train_data(:, 1:7);
glob_preds_28_days_ahead_from_300_with_300_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_300_with_300_train_data.csv'));
glob_preds_7_days_ahead_from_300_with_300_train_data = ...
    glob_preds_28_days_ahead_from_300_with_300_train_data(:, 1:7);

glob_preds_28_days_ahead_from_500_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_500_with_50_train_data.csv'));
glob_preds_7_days_ahead_from_500_with_50_train_data = ...
    glob_preds_28_days_ahead_from_500_with_50_train_data(:, 1:7);
glob_preds_28_days_ahead_from_500_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_500_with_100_train_data.csv'));
glob_preds_7_days_ahead_from_500_with_100_train_data = ...
    glob_preds_28_days_ahead_from_500_with_100_train_data(:, 1:7);
glob_preds_28_days_ahead_from_500_with_500_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_500_with_500_train_data.csv'));
glob_preds_7_days_ahead_from_500_with_500_train_data = ...
    glob_preds_28_days_ahead_from_500_with_500_train_data(:, 1:7);

glob_preds_28_days_ahead_from_743_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_743_with_50_train_data.csv'));
glob_preds_7_days_ahead_from_743_with_50_train_data = ...
    glob_preds_28_days_ahead_from_743_with_50_train_data(:, 1:7);
glob_preds_28_days_ahead_from_743_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_743_with_100_train_data.csv'));
glob_preds_7_days_ahead_from_743_with_100_train_data = ...
    glob_preds_28_days_ahead_from_743_with_100_train_data(:, 1:7);
glob_preds_28_days_ahead_from_743_with_743_train_data = ...
    table2array(readtable(...
    'Predictions\glob_preds_28_days_ahead_from_743_with_743_train_data.csv'));
glob_preds_7_days_ahead_from_743_with_743_train_data = ...
    glob_preds_28_days_ahead_from_743_with_743_train_data(:, 1:7);


%%%%%%%%%%%%%%%%%%%% Gather Norwegian Forecasts %%%%%%%%%%%%%%%%%%%%

% Norway 28 day forecast with prediction scheme 1
nor_test_preds_28_days_ahead_from_100_with_50_train_data =  ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_100_with_50_train_data.csv'));
nor_test_preds_28_days_ahead_from_100_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_100_with_100_train_data.csv'));

nor_test_preds_28_days_ahead_from_264_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_264_with_50_train_data.csv'));
nor_test_preds_28_days_ahead_from_264_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_264_with_100_train_data.csv'));
nor_test_preds_28_days_ahead_from_264_with_264_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_264_with_264_train_data.csv'));

nor_test_preds_28_days_ahead_from_300_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_300_with_50_train_data.csv'));
nor_test_preds_28_days_ahead_from_300_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_300_with_100_train_data.csv'));
nor_test_preds_28_days_ahead_from_300_with_300_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_300_with_300_train_data.csv'));

nor_test_preds_28_days_ahead_from_500_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_500_with_50_train_data.csv'));
nor_test_preds_28_days_ahead_from_500_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_500_with_100_train_data.csv'));
nor_test_preds_28_days_ahead_from_500_with_500_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_500_with_500_train_data.csv'));

nor_test_preds_28_days_ahead_from_696_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_696_with_50_train_data.csv'));
nor_test_preds_28_days_ahead_from_696_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_696_with_100_train_data.csv'));
nor_test_preds_28_days_ahead_from_696_with_696_train_data = ...
    table2array(readtable(...
    'Predictions\nor_test_preds_28_days_ahead_from_696_with_696_train_data.csv'));


% Norway seven (and 28) day forecasts with prediction scheme 2
nor_preds_28_days_ahead_from_100_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_100_with_50_train_data.csv'));
nor_preds_7_days_ahead_from_100_with_50_train_data = ...
    nor_preds_28_days_ahead_from_100_with_50_train_data(:, 1:7);
nor_preds_28_days_ahead_from_100_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_100_with_100_train_data.csv'));
nor_preds_7_days_ahead_from_100_with_100_train_data = ...
    nor_preds_28_days_ahead_from_100_with_100_train_data(:, 1:7);

nor_preds_28_days_ahead_from_264_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_264_with_50_train_data.csv'));
nor_preds_7_days_ahead_from_264_with_50_train_data = ...
    nor_preds_28_days_ahead_from_264_with_50_train_data(:, 1:7);
nor_preds_28_days_ahead_from_264_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_264_with_100_train_data.csv'));
nor_preds_7_days_ahead_from_264_with_100_train_data = ...
    nor_preds_28_days_ahead_from_264_with_100_train_data(:, 1:7);
nor_preds_28_days_ahead_from_264_with_264_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_264_with_264_train_data.csv'));
nor_preds_7_days_ahead_from_264_with_264_train_data = ...
    nor_preds_28_days_ahead_from_264_with_264_train_data(:, 1:7);

nor_preds_28_days_ahead_from_300_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_300_with_50_train_data.csv'));
nor_preds_7_days_ahead_from_300_with_50_train_data = ...
    nor_preds_28_days_ahead_from_300_with_50_train_data(:, 1:7);
nor_preds_28_days_ahead_from_300_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_300_with_100_train_data.csv'));
nor_preds_7_days_ahead_from_300_with_100_train_data = ...
    nor_preds_28_days_ahead_from_300_with_100_train_data(:, 1:7);
nor_preds_28_days_ahead_from_300_with_300_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_300_with_300_train_data.csv'));
nor_preds_7_days_ahead_from_300_with_300_train_data = ...
    nor_preds_28_days_ahead_from_300_with_300_train_data(:, 1:7);

nor_preds_28_days_ahead_from_500_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_500_with_50_train_data.csv'));
nor_preds_7_days_ahead_from_500_with_50_train_data = ...
    nor_preds_28_days_ahead_from_500_with_50_train_data(:, 1:7);
nor_preds_28_days_ahead_from_500_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_500_with_100_train_data.csv'));
nor_preds_7_days_ahead_from_500_with_100_train_data = ...
    nor_preds_28_days_ahead_from_500_with_100_train_data(:, 1:7);
nor_preds_28_days_ahead_from_500_with_500_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_500_with_500_train_data.csv'));
nor_preds_7_days_ahead_from_500_with_500_train_data = ...
    nor_preds_28_days_ahead_from_500_with_500_train_data(:, 1:7);

nor_preds_28_days_ahead_from_696_with_50_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_696_with_50_train_data.csv'));
nor_preds_7_days_ahead_from_696_with_50_train_data = ...
    nor_preds_28_days_ahead_from_696_with_50_train_data(:, 1:7);
nor_preds_28_days_ahead_from_696_with_100_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_696_with_100_train_data.csv'));
nor_preds_7_days_ahead_from_696_with_100_train_data = ...
    nor_preds_28_days_ahead_from_696_with_100_train_data(:, 1:7);
nor_preds_28_days_ahead_from_696_with_696_train_data = ...
    table2array(readtable(...
    'Predictions\nor_preds_28_days_ahead_from_696_with_696_train_data.csv'));
nor_preds_7_days_ahead_from_696_with_696_train_data = ...
    nor_preds_28_days_ahead_from_696_with_696_train_data(:, 1:7);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Plots %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% plot_norway_and_global_time_series_and_transform(ts, ts_global, false)
% % 
% plot_norway_and_global_time_series_and_transform(ts, ts_global, true)


%%%%%%%%%%%%%%%%%%%% Norwegian Forecasts %%%%%%%%%%%%%%%%%%%%

% plot_preds_sarima_gandalf(ts, 264, 264, 7, false) 
% plot_acf_of_res(ts, 264, 264, false)
% plot_acf_of_res(ts, 264, 264, true)

% plot_10_norway_CNN_LSTM_Preds(floor(exp(ts)), ...
%     nor_preds_7_days_ahead_from_264_with_264_train_data, 264, 264, 7, false)
% plot_preds_without_observed(ts, ...
%     mean(nor_preds_7_days_ahead_from_264_with_264_train_data, 1), ...
%     264, 264, 7, false, 14)
% plot_10_norway_CNN_LSTM_Preds(floor(exp(ts)), ...
%     nor_test_preds_28_days_ahead_from_264_with_264_train_data, ...
%     264, 264, 28, false)
% plot_preds_with_observed(ts, ...
%     mean(nor_test_preds_28_days_ahead_from_264_with_264_train_data, 1), ...
%     264, 264, 28, false, 30)
% 
% 
% plot_parameters_from_prediction_scheme_1(ts, 264, 264, 28, false)
% 
% plot_preds_without_observed(ts, ...
%     mean(nor_preds_7_days_ahead_from_264_with_50_train_data, 1), ...
%     264, 50, 7, false, 14)
% plot_preds_with_observed(ts, ...
%     mean(nor_test_preds_28_days_ahead_from_264_with_50_train_data, 1), ...
%     264, 50, 28, false, 21)
% plot_parameters_from_prediction_scheme_1(ts, 264, 50, 28, false)
plot_preds_without_observed(ts, ...
    mean(nor_preds_7_days_ahead_from_264_with_100_train_data, 1), ...
    264, 100, 7, false, 14)
% plot_preds_with_observed(ts, ...
%     mean(nor_test_preds_28_days_ahead_from_264_with_100_train_data, 1), ...
%     264, 100, 28, false, 30)
% plot_parameters_from_prediction_scheme_1(ts, 264, 100, 28, false)


%%%%%%%%%%%%%%%%%%%% Global Forecasts %%%%%%%%%%%%%%%%%%%%

% plot_loss_function(loss_func)

% plot_10_global_CNN_LSTM_Preds(floor(exp(ts_global)), ...
%     glob_test_preds_28_days_ahead_from_196_with_196_train_data, ...
%     196, 196, 28, true)
% plot_preds_sarima_gandalf(ts_global, 196, 196, 7, true) 
% plot_acf_of_res(ts_global, 196, 196, false)
% plot_acf_of_res(ts_global, 196, 196, true)
% 
% plot_preds_without_observed(ts_global, ...
%     mean(glob_preds_7_days_ahead_from_196_with_196_train_data,1), ...
%     196, 196, 7, true, 14)
% plot_preds_with_observed(ts_global, ...
%     mean(glob_test_preds_28_days_ahead_from_196_with_196_train_data, 1), ...
%     196, 196, 28, true, 30)
% plot_parameters_from_prediction_scheme_1(ts_global, 196, 196, 28, true)
% 
% plot_10_global_CNN_LSTM_Preds(floor(exp(ts_global)), ...
%     glob_preds_28_days_ahead_from_196_with_196_train_data, ...
%     196, 196, 28, true)
% plot_preds_without_observed(ts_global, ...
%     mean(glob_preds_28_days_ahead_from_196_with_196_train_data, 1), ...
%     196, 196, 28, true, 30)


%%%%%%%%%%%%%%%%%%%%% Results for table 2 %%%%%%%%%%%%%%%%%%%%%


% Generate all numbers to be inserted in table
% Norway:
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_100_with_50_train_data, 100, 50, 7)
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_100_with_100_train_data, 100, 100, 7)
% 
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_264_with_50_train_data, 264, 50, 7)
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_264_with_100_train_data, 264, 100, 7)
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_264_with_264_train_data, 264, 264, 7)
% 
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_300_with_50_train_data, 300, 50, 7)
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_300_with_100_train_data, 300, 100, 7)
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_300_with_300_train_data, 300, 300, 7)
% 
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_500_with_50_train_data, 500, 50, 7)
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_500_with_100_train_data, 500, 100, 7)
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_500_with_500_train_data, 500, 500, 7)
% 
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_696_with_50_train_data, 696, 50, 7)
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_696_with_100_train_data, 696, 100, 7)
% extract_percision_results_without_observed(ts, nor_preds_7_days_ahead_from_696_with_696_train_data, 696, 696, 7)
% 
% 
% 
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_100_with_50_train_data, 100, 50, 28)
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_100_with_100_train_data, 100, 100, 28)
% 
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_264_with_50_train_data, 264, 50, 28)
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_264_with_100_train_data, 264, 100, 28)
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_264_with_264_train_data, 264, 264, 28)
% 
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_300_with_50_train_data, 300, 50, 28)
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_300_with_100_train_data, 300, 100, 28)
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_300_with_300_train_data, 300, 300, 28)
% 
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_500_with_50_train_data, 500, 50, 28)
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_500_with_100_train_data, 500, 100, 28)
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_500_with_500_train_data, 500, 500, 28)
% 
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_696_with_50_train_data, 696, 50, 28)
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_696_with_100_train_data, 696, 100, 28)
% extract_percision_results_with_observed(ts, nor_test_preds_28_days_ahead_from_696_with_696_train_data, 696, 696, 28)
% 
% Global:
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_100_with_50_train_data, 100, 50, 7)
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_100_with_100_train_data, 100, 100, 7)
% 
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_196_with_50_train_data, 196, 50, 7)
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_196_with_100_train_data, 196, 100, 7)
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_196_with_196_train_data, 196, 196, 7)
% 
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_300_with_50_train_data, 300, 50, 7)
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_300_with_100_train_data, 300, 100, 7)
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_300_with_300_train_data, 300, 300, 7)
% 
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_500_with_50_train_data, 500, 50, 7)
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_500_with_100_train_data, 500, 100, 7)
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_500_with_500_train_data, 500, 500, 7)
% 
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_743_with_50_train_data, 743, 50, 7)
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_743_with_100_train_data, 743, 100, 7)
% extract_percision_results_without_observed(ts_global, glob_preds_7_days_ahead_from_743_with_743_train_data, 743, 743, 7)
% 
% 
% 
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_100_with_50_train_data, 100, 50, 28)
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_100_with_100_train_data, 100, 100, 28)
% 
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_196_with_50_train_data, 196, 50, 28)
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_196_with_100_train_data, 196, 100, 28)
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_196_with_196_train_data, 196, 196, 28)
% 
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_300_with_50_train_data, 300, 50, 28)
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_300_with_100_train_data, 300, 100, 28)
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_300_with_300_train_data, 300, 300, 28)
% 
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_500_with_50_train_data, 500, 50, 28)
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_500_with_100_train_data, 500, 100, 28)
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_500_with_500_train_data, 500, 500, 28)
% % 
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_743_with_50_train_data, 743, 50, 28)
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_743_with_100_train_data, 743, 100, 28)
% extract_percision_results_with_observed(ts_global, glob_test_preds_28_days_ahead_from_743_with_743_train_data, 743, 743, 28)



%%%%%%%%%%%%%%%%%%%%%%% Study table with bar plots %%%%%%%%%%%%%%%%%%%%%%%

% Gather measures from Table 2 to plot summarized results:
% RRMSE:
results_RRMSE_28_day_preds = [74 75 73; 60 262 53; 12 10 18; 11 11 25; 
    11 11 28; 25 27 29; 25 24 17; 28 28 26; 14 15 30; 15 15 35; 16 16 19; 
    11 9 19; 9 9 30; 9 9 46; 7 7 7; 6 6 10; 4 5 5; 4 4 4; 4 4 4; 5 7 12; 
    5 5 9; 6 6 11; 4 6 9; 5 5 15; 5 5 39; 9 7 21; 7 7 21; 7 7 85];

results_RRMSE_7_day_preds = [119 119 64; 87 87 65; 17 6 8; 16 15 11; 
    12 12 12; 17 17 14; 19 20 7; 16 16 18; 10 14 8; 5 8 12; 
    21 21 11; 9 8 23; 9 11 24; 13 4 24; 
    
    30 35 11; 16 16 14; 7 6 8; 4 4 6; 4 4 5; 7 5 11; 7 7 8; 7 7 9; 4 10 13; 
    6 7 20; 3 3 18; 15 10 12; 12 14 10; 12 13 12];

input_bar_plot_RRMSE_days_ahead = [mean(results_RRMSE_28_day_preds, 1); ...
    mean(results_RRMSE_7_day_preds, 1)];

results_RRMSE_Norway = [results_RRMSE_7_day_preds(1:14, :); ...
    results_RRMSE_28_day_preds(1:14, :)];
results_RRMSE_Global = [results_RRMSE_7_day_preds(15:28, :); ...
    results_RRMSE_28_day_preds(15:28, :)];

input_bar_plot_RRMSE_data_set = [mean(results_RRMSE_Norway, 1); ...
    mean(results_RRMSE_Global, 1)];

results_RRMSE_full_data = ...
    [results_RRMSE_7_day_preds([1, 3, 6, 9, 12, 15, 17, 20, 23, 26], :); 
    results_RRMSE_28_day_preds([1, 3, 6, 9, 12, 15, 17, 20, 23, 26], :)];

results_RRMSE_100_data = ...
    [results_RRMSE_7_day_preds([1, 4, 7, 10, 13, 15, 18, 21, 24, 27], :); 
    results_RRMSE_28_day_preds([1, 4, 7, 10, 13, 15, 18, 21, 24, 27], :)];

results_RRMSE_50_data = ...
    [results_RRMSE_7_day_preds([2, 5, 8, 11, 14, 16, 19, 22, 25, 28], :); 
    results_RRMSE_28_day_preds([2, 5, 8, 11, 14, 16, 19, 22, 25, 28], :)];

input_bar_plot_RRMSE_sample_size = [mean(results_RRMSE_full_data, 1); ...
    mean(results_RRMSE_100_data, 1); mean(results_RRMSE_50_data, 1)];

input_bar_plot_RRMSE_models = mean([results_RRMSE_full_data; ...
    results_RRMSE_100_data; results_RRMSE_50_data],1);

% MAPE:
results_MAPE_7_day_preds = [100 100 88; 57 57 41; 16 6 8; 12 11 11; 
    9 9 11; 14 13 12; 15 16 7; 13 13 14; 7 11 8; 4 5 12; 17 17 9; 7 7 22; 
    7 9 18; 11 3 23; 28  31 10; 14 14 13; 6 6 6; 3 3 4; 4 4 3; 6 4 10;
    6 6 7; 6 6 8; 3 9 13; 6 6 20; 2 2 18; 12 9 12; 11 11 10; 11 10 11];

results_MAPE_28_day_preds = [61 62 87; 40 118 41; 9 8 17; 9 8 26; 8 8 28; 
    22 20 23; 20 19 23; 23 22 21; 11 12 12; 12 11 20; 13 12 23; 11 9 17; 
    9 9 31; 9 8 46; 
    
    6 5 6; 5 5 9; 3 4 3; 3 3 3; 3 3 3; 4 5 11; 4 4 8; 
    4 4 9; 4 5 8; 4 4 14; 4 4 39; 7 6 20; 6 6 20; 6 5 83];

input_bar_plot_MAPE_days_ahead = [mean(results_MAPE_28_day_preds, 1); ...
    mean(results_MAPE_7_day_preds, 1)];

results_MAPE_Norway = ...
    [results_MAPE_7_day_preds(1:14, :); results_MAPE_28_day_preds(1:14, :)];
results_MAPE_Global = ...
    [results_MAPE_7_day_preds(15:28, :); results_MAPE_28_day_preds(15:28, :)];

input_bar_plot_MAPE_data_set = [mean(results_MAPE_Norway, 1); ...
    mean(results_MAPE_Global, 1)];

results_MAPE_full_data = ...
    [results_MAPE_7_day_preds([1, 3, 6, 9, 12, 15, 17, 20, 23, 26], :); 
    results_MAPE_28_day_preds([1, 3, 6, 9, 12, 15, 17, 20, 23, 26], :)];

results_MAPE_100_data = ...
    [results_MAPE_7_day_preds([1, 4, 7, 10, 13, 15, 18, 21, 24, 27], :); 
    results_MAPE_28_day_preds([1, 4, 7, 10, 13, 15, 18, 21, 24, 27], :)];

results_MAPE_50_data = ...
    [results_MAPE_7_day_preds([2, 5, 8, 11, 14, 16, 19, 22, 25, 28], :); 
    results_MAPE_28_day_preds([2, 5, 8, 11, 14, 16, 19, 22, 25, 28], :)];

input_bar_plot_MAPE_sample_size = [mean(results_MAPE_full_data, 1); ...
    mean(results_MAPE_100_data, 1); mean(results_MAPE_50_data, 1)];


input_bar_plot_MAPE_models = mean([results_MAPE_full_data; ...
    results_MAPE_100_data; results_MAPE_50_data],1).';

% % Creating histogram for all RRMSEs:
% RRMSEs_from_table = ...
%     [results_RRMSE_28_day_preds; results_RRMSE_7_day_preds];
% RRMSEs_sarima_table = RRMSEs_from_table(:, 1);
% RRMSEs_gandalf_table = RRMSEs_from_table(:, 2);
% RRMSEs_cnn_table = RRMSEs_from_table(:, 3);
% figure
% sar = histogram(RRMSEs_sarima_table, 40, 'FaceColor', [0.4940 0.1840 0.5560]);
% mean(RRMSEs_sarima_table)
% mean_sar = xline(mean(RRMSEs_sarima_table),'--',...
%     'Color', [1 0 0], 'LineWidth',2);
% legend([sar mean_sar], 'SARIMA model','Mean RRMSE')
% xlabel('RRMSE')
% ylabel('Occurrences')
% set(gcf,'color','w')
% set(gca,'FontSize',24)
% % xticks(min(RRMSEs_sarima_table):5:max(RRMSEs_sarima_table))
% figure
% gand = histogram(RRMSEs_gandalf_table, 40, 'FaceColor', [.2, .9, .5]);
% mean(RRMSEs_gandalf_table)
% mean_gand = xline(mean(RRMSEs_gandalf_table),'--',...
%     'Color', [1 0 0], 'LineWidth',2);
% legend([gand mean_gand], 'Gandalf model','Mean RRMSE')
% xlabel('RRMSE')
% ylabel('Occurrences')
% set(gcf,'color','w')
% set(gca,'FontSize',24)
% 
% figure
% cnn = histogram(RRMSEs_cnn_table, 40, 'FaceColor', [0 0.4470 0.7410]);
% mean(RRMSEs_cnn_table)
% mean_cnn = xline(mean(RRMSEs_cnn_table),'--',...
%     'Color', [1 0 0], 'LineWidth',2);
% legend([cnn mean_cnn], 'CNN-LSTM model','Mean RRMSE')
% xlabel('RRMSE')
% ylabel('Occurrences')
% set(gcf,'color','w')
% set(gca,'FontSize',24)


% Creating histogram for all MAPEs:
% MAPEs_from_table =  [results_MAPE_28_day_preds; results_MAPE_7_day_preds];
% MAPEs_sarima_table = MAPEs_from_table(:, 1);
% MAPEs_gandalf_table = MAPEs_from_table(:, 2);
% MAPEs_cnn_table = MAPEs_from_table(:, 3);
% figure
% sar = histogram(MAPEs_sarima_table, 40, 'FaceColor', [0.4940 0.1840 0.5560]);
% mean(MAPEs_sarima_table)
% mean_sar = xline(mean(MAPEs_sarima_table),'--',...
%     'Color', [1 0 0], 'LineWidth',2);
% legend([sar mean_sar], 'SARIMA model','Mean MAPE')
% xlabel('MAPE')
% ylabel('Occurrences')
% set(gcf,'color','w')
% set(gca,'FontSize',24)
% % xticks(min(MAPEs_sarima_table):5:max(MAPEs_sarima_table))
% figure
% gand = histogram(MAPEs_gandalf_table, 40, 'FaceColor', [.2, .9, .5]);
% mean(MAPEs_gandalf_table)
% mean_gand = xline(mean(MAPEs_gandalf_table),'--',...
%     'Color', [1 0 0], 'LineWidth',2);
% legend([gand mean_gand], 'Gandalf model','Mean MAPE')
% xlabel('MAPE')
% ylabel('Occurrences')
% set(gcf,'color','w')
% set(gca,'FontSize',24)
% 
% figure
% cnn = histogram(MAPEs_cnn_table, 40, 'FaceColor', [0 0.4470 0.7410]);
% mean(MAPEs_cnn_table)
% mean_cnn = xline(mean(MAPEs_cnn_table),'--',...
%     'Color', [1 0 0], 'LineWidth',2);
% legend([cnn mean_cnn], 'CNN-LSTM model','Mean MAPE')
% xlabel('MAPE')
% ylabel('Occurrences')
% set(gcf,'color','w')
% set(gca,'FontSize',24)



%                                  
% bin_range = min(min(RRMSEs_from_table)):max(max(RRMSEs_from_table));                              
% counts_sarima = histc(RRMSEs_sarima, bin_range);
% counts_gandalf = histc(RRMSEs_gandalf, bin_range);      
% counts_cnn = histc(RRMSEs_cnn, bin_range);    
% counts_sarima_gandalf = counts_sarima  + counts_gandalf;
% counts_total = counts_sarima  + counts_gandalf + counts_cnn;
% 
% clr = [0 0.4470 0.7410; .2, .9, .5; 0.4940 0.1840 0.5560];
% colormap(clr);
% figure
% cnn = bar(bin_range, counts_total);
% hold on
% gand = bar(bin_range, counts_sarima_gandalf);
% sar = bar(bin_range, counts_sarima);
% hold off
% xlabel('RRMSE')
% ylabel('Occurrences')
% legend([sar, gand, cnn], 'SARIMA model', 'Gandalf model', 'CNN-LSTM model')
% set(gcf,'color','w')
% set(gca,'FontSize',24)
% set(h, {'DisplayName'}, {'SARIMA', 'Gandalf', 'CNN-LSTM'}')


% % Creating histogram for all MAPEs:
% MAPEs_from_table =  [results_MAPE_28_day_preds; results_MAPE_7_day_preds];
% MAPEs_sarima_table = MAPEs_from_table(:, 1);
% MAPEs_gandalf_table = MAPEs_from_table(:, 2);
% MAPEs_cnn_table = MAPEs_from_table(:, 3);
%                                  
% bin_range = min(min(MAPEs_from_table)):max(max(MAPEs_from_table));                              
% counts_sarima = histc(MAPEs_sarima, bin_range);
% counts_gandalf = histc(MAPEs_gandalf, bin_range);      
% counts_cnn = histc(MAPEs_cnn, bin_range);    
% counts_sarima_gandalf = counts_sarima  + counts_gandalf;
% counts_total = counts_sarima  + counts_gandalf + counts_cnn;
% 
% clr = [0 0.4470 0.7410; .2, .9, .5; 0.4940 0.1840 0.5560];
% colormap(clr);
% figure
% cnn = bar(bin_range, counts_total);
% hold on
% gand = bar(bin_range, counts_sarima_gandalf);
% sar = bar(bin_range, counts_sarima);
% hold off
% xlabel('MAPE')
% ylabel('Occurrences')
% legend([sar, gand, cnn], 'SARIMA model', 'Gandalf model', 'CNN-LSTM model')
% set(gcf,'color','w')
% set(gca,'FontSize',24)
% set(h, {'DisplayName'}, {'SARIMA', 'Gandalf', 'CNN-LSTM'}')




% Figure tu create bar plots, switch out text and so on depending on the
% spesific plot
% % figure
% h = bar(input_bar_plot_RRMSE_sample_size); % , 'stacked')
% % ylabel('median MAPE')
% ylabel('median RRMSE')
% % xlabel('Model')
% % xticklabels({'SARIMA', 'Gandalf', 'CNN-LSTM'})
% % xlabel('Data set')
% % xticklabels({'Norway', 'Global'})
% % xlabel('Days-ahead forecast')
% % xticklabels({'28 day', '7 day'})
% xlabel('Sample size')
% xticklabels({'All available', '100', '50'})
% set(gcf,'color','w')
% set(gca,'FontSize',24)
% set(h, {'DisplayName'}, {'SARIMA', 'Gandalf', 'CNN-LSTM'}')
% legend() 




%%%%%%%%%%%%%%%%%%%%%%%%% Simulation study %%%%%%%%%%%%%%%%%%%%%%%

% simulations = simulate_from_Gandalf(ts_global, 28, 196, 1000).';
% plot_simulations(ts_global, simulations.', 28, 196);
% predictions_on_simulations(ts_global, simulations(1:3, :), ...
%     pred_three_preds_on_sims, 28, 196, true);


RRMSEs_cnn = table2array(readtable(...
    'Predictions\RRMSEs_from_simulation_global_28_days_ahead_with_196_train_data_from196.csv'));
MAPEs_cnn = table2array(readtable(...
    'Predictions\MAPEs_from_simulation_global_28_days_ahead_with_196_train_data_from196.csv'));
pred_three_preds_on_sims = table2array(readtable(...
    'Predictions\pred_three_preds_on_sims.csv'));


%The below functions take approximately 20 hours to run with 1000 sims
% [RRMSEs_sarima, MAPEs_sarima, RRMSEs_gandalf, MAPEs_gandalf, ...
%     ma_sim, sma_sim, arch_sim, garch_sim] = ...
%      RRMSE_MAPE_from_simulation_sarima_and_gandalf...
%      (ts_global, simulations, 196, false);
% 
% [log_RRMSEs_sarima, log_MAPEs_sarima, ...
%     log_RRMSEs_gandalf, log_MAPEs_gandalf] = ...
%      RRMSE_MAPE_from_simulation_sarima_and_gandalf...
%      (ts_global, simulations, 196, true);
% 
% 
% % save('RRMSEs_sarima.mat','RRMSEs_sarima');
% % save('MAPEs_sarima.mat','MAPEs_sarima');
% % save('RRMSEs_gandalf.mat','RRMSEs_gandalf');
% % save('MAPEs_gandalf.mat','MAPEs_gandalf');
% % 
% % save('log_RRMSEs_gandalf.mat','log_RRMSEs_gandalf'); 
% % save('log_MAPEs_gandalf.mat','log_MAPEs_gandalf');
% 
% 
% load('RRMSEs_sarima.mat','RRMSEs_sarima'); 
% load('MAPEs_sarima.mat','MAPEs_sarima');
% load('RRMSEs_gandalf.mat','RRMSEs_gandalf'); 
% load('MAPEs_gandalf.mat','MAPEs_gandalf');
% load('log_RRMSEs_gandalf.mat','log_RRMSEs_gandalf'); 
% load('log_MAPEs_gandalf.mat','log_MAPEs_gandalf');
% 
% Plot the results:
% plot_simulated_RRMSE_MAPE(RRMSEs_cnn, MAPEs_cnn)
% plot_simulated_RRMSE_MAPE(RRMSEs_sarima, MAPEs_sarima)
% plot_simulated_RRMSE_MAPE(RRMSEs_gandalf, MAPEs_gandalf)
% plot_simulated_RRMSE_MAPE(log_RRMSEs_gandalf, log_MAPEs_gandalf)
% plot_simulated_parameters(ts_global, 196, ma_sim(1:200,:), ...
%     sma_sim(1:200,:), arch_sim(1:200,:), garch_sim(1:200,:))

function extract_percision_results_without_observed...
    (ts, preds_cnn, endpoint, len_train, days_ahead)
    % Does not show plot of predictions, only results. This was used to
    % fill out the summarized table. 
    sarima = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    gandalf.Variance = garchmod;

    train_data = ts(endpoint-len_train+1:endpoint);
    fitted_sarima = estimate(sarima, train_data, 'Display','off');
    fitted_gandalf= estimate(gandalf, train_data, 'Display','off');
    preds_sarima= forecast(fitted_sarima, days_ahead, train_data);
    preds_gandalf = forecast(fitted_gandalf, days_ahead, train_data);

    mean_preds_cnn = mean(preds_cnn, 1);
    %mse_cnn = mse_cnn_lstm(ts, mean_preds_cnn, endpoint, len_train, true);   

    % convert to normal scale where needed
    ts = floor(exp(ts));
    test_data = ts(endpoint+1: endpoint + days_ahead);
    preds_sarima = floor(exp(preds_sarima));
    preds_gandalf = floor(exp(preds_gandalf));

    % calculate RRMSE and MAPE for single predictions
    RRMSE_sarima = sqrt(mean((test_data - preds_sarima).^2))/mean(test_data)*100;
    MAPE_sarima = mean(abs(test_data - preds_sarima)./abs(test_data))*100;
    RRMSE_gandalf = sqrt(mean((test_data - preds_gandalf).^2))/mean(test_data)*100;
    MAPE_gandalf = mean(abs(test_data - preds_gandalf)./abs(test_data))*100;
    RRMSE_cnn = sqrt(mean((test_data - mean_preds_cnn.').^2))/mean(test_data)*100;
    MAPE_cnn = mean(abs(test_data - mean_preds_cnn.')./abs(test_data))*100;

    % calculate RRMAE and MAPE for the 10 CNN-LSTM models
    RRMSE = zeros(10, 1);
    MAPE = zeros(10, 1);
    for i = 1:10
        RRMSE(i) = sqrt(mean((test_data.' - preds_cnn(i, :)).^2))/mean(test_data)*100; 
        MAPE(i) = mean(abs(test_data.' - preds_cnn(i, :))./abs(test_data.'))*100;
    end

    mean_RRMSE_cnn = round(mean(RRMSE), 2);
    mean_MAPE_cnn = round(mean(MAPE), 2);
    
    disp("...................................................................................")
    disp(["Displaying the results from the ", days_ahead,"-day predictions starting at ", endpoint, ...
        " using ", len_train, " data without test data:"])
    disp(["RRMSE SARIMA: ", round(RRMSE_sarima, 2), ", MAPE SARIMA: ", round(MAPE_sarima, 2)])
    disp(["RRMSE Gandalf: ", round(RRMSE_gandalf, 2), ", MAPE Gandalf: ", round(MAPE_gandalf, 2)])
    disp(["RRMSE mean CNN-LSTM: ", round(RRMSE_cnn, 2), ", MAPE mean CNN-LSTM: ", round(MAPE_cnn, 2)])
    disp(["Mean RRMSE of ten CNN-LSTM models: ", round(mean_RRMSE_cnn, 2), ", Mean MAPE of ten CNN-LSTM models: ", round(mean_MAPE_cnn, 2)])
    

end

function extract_percision_results_with_observed...
    (ts, preds_cnn, endpoint, len_train, days_ahead)
    % Does not show plot of predictions, only results. This was used to
    % fill out the summarizinf table. 
    sarima = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    gandalf.Variance = garchmod;

    preds_sarima = [];
    preds_gandalf = [];
  
    train_data = ts(endpoint-len_train+1:endpoint);
    for i = 1:days_ahead
        fitted_sarima = estimate(sarima, train_data, 'Display','off');
        fitted_gandalf= estimate(gandalf, train_data, 'Display','off');
        preds_sarima(end+1) = forecast(fitted_sarima, 1, train_data);
        preds_gandalf(end+1) = forecast(fitted_gandalf, 1, train_data);
        train_data = [train_data; ts(endpoint+i)]; % add next observation to training data
    end
    
    mean_preds_cnn = mean(preds_cnn, 1);
    %mse_cnn = mse_cnn_lstm(ts, mean_preds_cnn, endpoint, len_train, true);   

    % convert to normal scale where needed
    ts = floor(exp(ts));
    test_data = ts(endpoint+1: endpoint + days_ahead);
    preds_sarima = floor(exp(preds_sarima));
    preds_gandalf = floor(exp(preds_gandalf));

    % calculate RRMSE and MAPE for single predictions
    RRMSE_sarima = sqrt(mean((test_data - preds_sarima.').^2))/mean(test_data)*100;
    MAPE_sarima = mean(abs(test_data - preds_sarima.')./abs(test_data))*100;
    RRMSE_gandalf = sqrt(mean((test_data - preds_gandalf.').^2))/mean(test_data)*100;
    MAPE_gandalf = mean(abs(test_data - preds_gandalf.')./abs(test_data))*100;
    RRMSE_cnn = sqrt(mean((test_data - mean_preds_cnn.').^2))/mean(test_data)*100;
    MAPE_cnn = mean(abs(test_data - mean_preds_cnn.')./abs(test_data))*100;

    % calculate RRMAE and MAPE for the 10 CNN-LSTM models
    RRMSE = zeros(10, 1);
    MAPE = zeros(10, 1);
    for i = 1:10
        RRMSE(i) = sqrt(mean((test_data.' - preds_cnn(i, :)).^2))/mean(test_data)*100; 
        MAPE(i) = mean(abs(test_data.' - preds_cnn(i, :))./abs(test_data.'))*100;
    end

    mean_RRMSE_cnn = round(mean(RRMSE), 2);
    mean_MAPE_cnn = round(mean(MAPE), 2);
    disp("...................................................................................")
    disp(["Displaying the results from the ", days_ahead,"-day predictions starting at ", ...
        endpoint, " using ", len_train, " data with test data:"])
    disp(["RRMSE SARIMA: ", round(RRMSE_sarima, 2), ", MAPE SARIMA: ", round(MAPE_sarima, 2)])
    disp(["RRMSE Gandalf: ", round(RRMSE_gandalf, 2), ", MAPE Gandalf: ", round(MAPE_gandalf, 2)])
    disp(["RRMSE mean CNN-LSTM: ", round(RRMSE_cnn, 2), ", MAPE mean CNN-LSTM: ", round(MAPE_cnn, 2)])
    disp(["Mean RRMSE of ten CNN-LSTM models: ", round(mean_RRMSE_cnn, 2), ", Mean MAPE of ten CNN-LSTM models: ", round(mean_MAPE_cnn, 2)])
    


end

function predictions_on_simulations...
    (ts, simulations, preds_sim_cnn, days_ahead, endpoint, is_global)
% Displays three forecasts on simulated realizations
sarima = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
gandalf.Variance = garchmod;

% simulation was on normal scale
simulations = log(max(simulations, 0.1));
tic
for i = 1:size(simulations,1) % iterate through each simulation

    preds_sim_cnn(i,:)
    train_data = ts(1:endpoint);

    % Extract params from simulation model
    preds_sarima = [];
    preds_gandalf = [];
    mse_sarima = [];
    mse_gandalf = [];
    
    % make predictions, iterating through the current simulation
    for j = 1:size(simulations,2)
        fitted_sarima = estimate(sarima, train_data, 'Display','off');
        fitted_gandalf= estimate(gandalf, train_data, 'Display','off');
        [preds_sarima(end+1), mse_sarima(end+1)] = forecast(fitted_sarima, 1, train_data);
        [preds_gandalf(end+1), mse_gandalf(end+1)] = forecast(fitted_gandalf, 1, train_data);
        train_data = [train_data; simulations(i,j)]; % add next simulation to training data
    end
    % revert predictions and simulations back to normal scale
    upper_sarima = preds_sarima + 1.96*sqrt(mse_sarima);
    lower_sarima = preds_sarima - 1.96*sqrt(mse_sarima);
    upper_gandalf = preds_gandalf + 1.96*sqrt(mse_gandalf);
    lower_gandalf =  preds_gandalf - 1.96*sqrt(mse_gandalf);

    % convert to normal scale where needed
    simulations(i,:) = floor(exp(simulations(i,:)));
    preds_sarima = floor(exp(preds_sarima));preds_gandalf = floor(exp(preds_gandalf));
    upper_sarima = floor(exp(upper_sarima));lower_sarima = floor(exp(lower_sarima));
    upper_gandalf = floor(exp(upper_gandalf));lower_gandalf = floor(exp(lower_gandalf));
    
    plot_length = 21;

    if is_global
        dates_train = index_to_date_global(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_global(endpoint:endpoint+days_ahead-1);
    else
        dates_train = index_to_date_norway(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_norway(endpoint:endpoint+days_ahead-1);
    end

    RRMSE_sarima = sqrt(mean((simulations(i,:) - preds_sarima).^2))/mean(simulations(i,:))*100; 
    MAPE_sarima = mean(abs(simulations(i,:) - preds_sarima)./abs(simulations(i,:)))*100;
    RRMSE_gandalf = sqrt(mean((simulations(i,:) - preds_gandalf).^2))/mean(simulations(i,:))*100; 
    MAPE_gandalf = mean(abs(simulations(i,:) - preds_gandalf)./abs(simulations(i,:)))*100;
    RRMSE_cnn = sqrt(mean((simulations(i,:) - preds_sim_cnn(i,:)).^2))/mean(simulations(i,:))*100; 
    MAPE_cnn = mean(abs(simulations(i,:) - preds_sim_cnn(i,:))./abs(simulations(i,:)))*100;
    
    
    figure
    hold on
    data = plot(dates_train, floor(exp(ts(endpoint-plot_length+1:endpoint))),'Color',[0.25, 0.25, 0.25]);
    obs = plot(dates_test,simulations(i,:), 'Color', '#A2142F','LineWidth',3);
    predictions_sarima = plot(dates_test,preds_sarima, 'Color', [0.4940 0.1840 0.5560], 'LineWidth',2);
    u_sarima = plot(dates_test,upper_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    l_sarima = plot(dates_test,lower_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    predictions_gandalf = plot(dates_test,preds_gandalf, 'Color', [.2, .9, .5], 'LineWidth',2);
    u_gandalf = plot(dates_test,upper_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1);
    l_gandalf = plot(dates_test,lower_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1); 
    cnn = plot(dates_test,preds_sim_cnn(i,:), 'Color', [0 0.4470 0.7410], 'LineWidth',2);
    % gtext(['RRMSE sarima: ', num2str(RRMSE_sarima), newline,'RRMSE gandalf: ', num2str(RRMSE_gandalf)],'FontSize', 24)

    gtext([ ...
        '\color[rgb]{' sprintf('%f,%f,%f', [0.4940 0.1840 0.5560] ) '} SARIMA model: RRMSE = ', num2str(round(RRMSE_sarima, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_sarima, 2)), '%',newline, ...
        '\color[rgb]{' sprintf('%f,%f,%f', [.2, .9, .5]) '} Gandalf model: RRMSE = ', num2str(round(RRMSE_gandalf, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_gandalf, 2)), '%', newline, ...
        '\color[rgb]{' sprintf('%f,%f,%f', [0 0.4470 0.7410]) '} CNN-LSTM model: RRMSE = ', num2str(round(RRMSE_cnn, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_cnn, 2)), '%',
        ], 'Interpreter', 'tex','FontSize', 30);

    legend([data, obs, predictions_sarima, u_sarima, predictions_gandalf, u_gandalf cnn],... 
        'Training data', 'Simulated realization', 'Forecast SARIMA','95% interval SARIMA', ...
        'Forecast Gandalf','95% interval Gandalf', 'Forecast CNN-LSTM', 'Location', 'NorthWest','FontSize', 30) 
    ylabel('New cases')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    hold off
    ax = gca;
    if is_global
        ax.YAxis.Exponent = 3;
    else
        ax.YAxis.Exponent = 0;
    end
    hold off
end
toc
end

function plot_simulated_parameters...
    (ts, endpoint, ma_sim, sma_sim, arch_sim, garch_sim)
    %ma_sim = 28x1000 array
    gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    gandalf.Variance = garchmod;
    
    [~, variances]= estimate(gandalf, ts(1:196), 'Display','off');
    SDs = diag(variances).^0.5;
    SDs = SDs([2 3 6 5]).';


    % first element contain parametes fitted on training data only:
    original_ma = repelem(ma_sim(1,1),34); 
    upper_ma = original_ma +2*SDs(1);
    lower_ma = original_ma -2*SDs(1);
    original_sma = repelem(sma_sim(1,1),34);
    upper_sma = original_sma +2*SDs(2);
    lower_sma = original_sma -2*SDs(2);
    original_arch = repelem(arch_sim(1,1),34);
    upper_arch = original_arch +2*SDs(3);
    lower_arch = original_arch -2*SDs(3);
    original_garch = repelem(garch_sim(1,1),34);
    upper_garch = original_garch +2*SDs(4);
    lower_garch = original_garch -2*SDs(4);

    % Plotting
    dates_before = index_to_date_global(endpoint-3:endpoint-1);
    dates_sim = index_to_date_global(endpoint:endpoint+27);
    dates_after = index_to_date_global(endpoint+28:endpoint + 30);

    figure 
    subplot(2,2,1)
    hold on
    orig_ma = plot([dates_before dates_sim dates_after], original_ma, '--', 'Color', 'red', 'LineWidth', 2);
    up_ma = plot([dates_before dates_sim dates_after], upper_ma, '--', 'Color', 'black', 'LineWidth', 1);
    low_ma = plot([dates_before dates_sim dates_after], lower_ma, '--', 'Color', 'black', 'LineWidth', 1);
    ma = plot(dates_sim, ma_sim, 'LineWidth', 1, 'Color', 'red');
    ylabel('Estimated \theta_{MA}')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    legend([orig_ma up_ma ma(1)], 'Estimated \theta_{MA} on training data', ...
        'Condidence interval on training data',...
        'Estimated \theta_{MA} on simulations', 'Location', 'northwest');
    hold off

    subplot(2,2,2)
    hold on
    orig_sma = plot([dates_before dates_sim dates_after], original_sma, '--', 'Color', [0 1 0.7], 'LineWidth', 2);
    up_sma = plot([dates_before dates_sim dates_after], upper_sma, '--', 'Color', 'black', 'LineWidth', 1);
    low_sma = plot([dates_before dates_sim dates_after], lower_sma, '--', 'Color', 'black', 'LineWidth', 1);
    sma = plot(dates_sim, sma_sim, 'LineWidth', 1, 'Color', [0 1 0.7]);
    ylabel('Estimated \theta_{SMA}')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    legend([orig_sma up_sma sma(1)], 'Estimated \theta_{SMA} on training data', ...
        'Condidence interval on training data',...
        'Estimated \theta_{SMA} on simulations', 'Location', 'northwest');
    hold off

    subplot(2,2,3)
    hold on
    orig_arch = plot([dates_before dates_sim dates_after], original_arch, '--', 'Color', 'blue', 'LineWidth', 2);
    arch = plot(dates_sim, arch_sim, 'LineWidth', 1, 'Color', 'blue');
    up_arch = plot([dates_before dates_sim dates_after], upper_arch, '--', 'Color', 'black', 'LineWidth', 1);
    low_arch = plot([dates_before dates_sim dates_after], lower_arch, '--', 'Color', 'black', 'LineWidth', 1);
    ylabel('Estimated \alpha_1')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    legend([orig_arch up_arch arch(1)], 'Estimated \alpha_1 on training data', ...
        'Condidence interval on training data',...
        'Estimated \alpha_1 on simulations', 'Location', 'northwest');
    hold off

    subplot(2,2,4)
    hold on
    orig_garch = plot([dates_before dates_sim dates_after], original_garch, '--', 'Color', 'green', 'LineWidth', 2);
    garch_ = plot(dates_sim, garch_sim, 'LineWidth', 1, 'Color', 'green');
    up_garch = plot([dates_before dates_sim dates_after], upper_garch, '--', 'Color', 'black', 'LineWidth', 1);
    low_garch = plot([dates_before dates_sim dates_after], lower_garch, '--', 'Color', 'black', 'LineWidth', 1);
    ylabel('Estimated \beta_1')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    legend([orig_garch up_garch garch_(1)], 'Estimated \beta_1 on training data', ...
        'Condidence interval on training data',...
        'Estimated \beta_1 on simulations', 'Location', 'northwest');
    hold off
end 

function plot_simulated_RRMSE_MAPE(RRMSEs, MAPEs)

% Uncomment the corresponding accuracy measures on the original data set
%     mean_RRMSE_orig = 3.86; % RRMSE on original SARIMA
%     mean_MAPE_orig = 2.89; % MAPE on original SARIMA
%     mean_RRMSE_orig = 4.81; % RRMSE on original Gandalf
%     mean_MAPE_orig = 3.56; % MAPE on original Gandalf
    mean_RRMSE_orig = 0.3574; % RRMSE on original Gandalf log scale
    mean_MAPE_orig = 0.2834; % MAPE on original Gandalf log scale
    
%     mean_RRMSE_orig = 4.58; % RRMSE on original CNN-LSTM
%     mean_MAPE_orig = 3.21; % MAPE on original CNN-LSTM

    figure
    set(gcf,'color','w')
    subplot(1, 2, 1)
    hold on
    h = histogram(RRMSEs, 100, 'FaceColor', '#00b551', 'EdgeColor','#00b551');
    orig_RRMSE = xline(mean_RRMSE_orig,'--',['Original RRMSE: ', num2str(mean_RRMSE_orig)], ...
        'Color', [0 0 1], 'LineWidth',2, 'FontSize',16);
    ylabel("Frequency")
    xlabel("RRMSE")
    hold off
    set(gca,'FontSize',24)
    subplot(1, 2, 2)
    hold on
    h = histogram(MAPEs, 100, 'FaceColor', '#ad003d', 'EdgeColor','#ad003d');
    orig_MAPE = xline(mean_MAPE_orig,'--',['Original MAPE: ', num2str(mean_MAPE_orig)], ...
        'Color', [0 0 1], 'LineWidth',2, 'FontSize',16);
    ylabel("Frequency")
    xlabel("MAPE")
    hold off
    set(gca,'FontSize',24)
end

function [RRMSEs_sarima, MAPEs_sarima, RRMSEs_gandalf, MAPEs_gandalf, ...
    ma_sim, sma_sim, arch_sim, garch_sim] = ...
    RRMSE_MAPE_from_simulation_sarima_and_gandalf(ts, simulations,  endpoint, log_scale)
% This function predicts one step ahead with simulated data from
% Gandalf model using the SARIMA model and the Gandalf model
sarima = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
gandalf.Variance = garchmod;


RRMSEs_sarima = [];
MAPEs_sarima = [];
RRMSEs_gandalf = [];
MAPEs_gandalf = [];

ma_sim = [];
sma_sim = [];
arch_sim = [];
garch_sim = [];

simulations = log(max(simulations, 0.1));

% RRMSE and MAPE on the real test data, for reference later:
train_data = ts(1:endpoint);
preds_sarima = [];
preds_gandalf = [];

for i = 1:size(simulations,2)
    fitted_sarima = estimate(sarima, train_data, 'Display','off');
    fitted_gandalf= estimate(gandalf, train_data, 'Display','off');
    preds_sarima(end+1) = forecast(fitted_sarima, 1, train_data);
    preds_gandalf(end+1) = forecast(fitted_gandalf, 1, train_data);
    train_data = [train_data; ts(endpoint+i)]; % add next simulation to training data
end



test_data = ts(endpoint+1:endpoint+size(simulations,2));

% Idé: Ta ut parameterverdiene i loopen over

RRMSE_sarima_orig = sqrt(mean((test_data - preds_sarima.').^2))/mean(test_data)*100
MAPE_sarima_orig = mean(abs(test_data - preds_sarima.')./abs(test_data))*100
RRMSE_gandalf_orig = sqrt(mean((test_data - preds_gandalf.').^2))/mean(test_data)*100
MAPE_gandalf_orig = mean(abs(test_data - preds_gandalf.')./abs(test_data))*100


% simulation was on normal scale, need to be on log-scale to fulfill the
% SARIMA models assumptions.

tic
for i = 1:size(simulations,1) % iterate through each simulation
    train_data = ts(1:endpoint);
    preds_sarima = [];
    preds_gandalf = [];

    ma = [];
    sma = [];
    arch = [];
    garch_ = [];
    % make predictions, iterating through the current simulation
    for j = 1:size(simulations,2)
        fitted_sarima = estimate(sarima, train_data, 'Display','off');
        fitted_gandalf= estimate(gandalf, train_data, 'Display','off');

        ma(end+1) = round(cell2mat(fitted_gandalf.MA), 4);
        sma(end+1)  = round(cell2mat(fitted_gandalf.SMA(7)), 4);
        arch(end+1) = round(cell2mat(fitted_gandalf.Variance.ARCH), 4);
        garch_(end+1)  = round(cell2mat(fitted_gandalf.Variance.GARCH), 4);

        preds_sarima(end+1) = forecast(fitted_sarima, 1, train_data);
        preds_gandalf(end+1) = forecast(fitted_gandalf, 1, train_data);
        train_data = [train_data; simulations(i,j)]; % add next simulation to training data
    end

    if log_scale == false
        % revert predictions and simulations back to normal scale
        preds_sarima = floor(exp(preds_sarima));
        preds_gandalf = floor(exp(preds_gandalf));
        simulations(i,:) = floor(exp(simulations(i,:)));
    end
    
    % add parameters 
    ma_sim = [ma_sim; ma];
    sma_sim = [sma_sim; sma];
    arch_sim = [arch_sim; arch];
    garch_sim = [garch_sim; garch_];
    
    % calculate RRMSE and MAPE
    RRMSEs_sarima(end+1) = sqrt(mean((simulations(i, :) - preds_sarima).^2))/mean(simulations(i, :))*100;
    MAPEs_sarima(end+1) = mean(abs(simulations(i, :) - preds_sarima)./abs(simulations(i, :)))*100;
    RRMSEs_gandalf(end+1) = sqrt(mean((simulations(i, :) - preds_gandalf).^2))/mean(simulations(i, :))*100;
    MAPEs_gandalf(end+1) = mean(abs(simulations(i, :) - preds_gandalf)./abs(simulations(i, :)))*100;
    length(MAPEs_gandalf) % To monitor progress
end
toc
end

function plot_simulations(ts, simulations, days_ahead, endpoint)
    gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    gandalf.Variance = garchmod;
    
    train_data = ts(1:endpoint);
%     test_data = floor(exp(ts(endpoint+1:endpoint+28)));
    rng(123) % Set seed for reproducability
    fitted_model = estimate(gandalf, train_data, 'Display', 'off');
    [prediction, YMSE]= forecast(fitted_model, days_ahead, 'Y0', train_data);
    upper =  prediction + 1.96*sqrt(YMSE);
    lower =  prediction - 1.96*sqrt(YMSE);
    prediction = floor(exp(prediction)); upper = floor(exp(upper)); lower = floor(exp(lower)); 

    % Plot
    plot_length = 21;
    dates_train = index_to_date_global(endpoint-plot_length+1:endpoint);
    dates_test = index_to_date_global(endpoint+1:endpoint+days_ahead);
    figure
    hold on
    data = plot(dates_train, floor(exp(ts(endpoint-plot_length+1:endpoint))),'Color',[0.25, 0.25, 0.25]);
    obs = plot(dates_test,floor(exp(ts(endpoint+1:endpoint+days_ahead))), 'Color', [1, 0, 0],'LineWidth',3);
    pred = plot(dates_test,prediction, 'Color', [.2, .9, .5], 'LineWidth',2);
    up = plot(dates_test,upper, '--', 'Color', [.2, .9, .5], 'LineWidth',1);
    low = plot(dates_test,lower, '--', 'Color', [.2, .9, .5], 'LineWidth',1);
    sims = plot(dates_test,simulations(:,1:3), 'Color', '#A2142F', 'LineWidth',2);
    up_sims = plot(dates_test,prctile(simulations,97.5,2), '--','Color', 'b', 'LineWidth',1);
    low_sims = plot(dates_test,prctile(simulations,2.5,2), '--','Color', 'b', 'LineWidth',1);
    %med_sims = plot(dates_test,median(simulations,2), 'Color', 'b', 'LineWidth',2);
    % Hvis du vil plotte alle med gjennomsiktighet
    %     for i=1:length(sims)
    %     sims(i).Color = [sims(i).Color 0.05];  % alpha=0.1
    %     end
    legend([data obs sims(1) pred up up_sims], 'Training data', 'Test data', 'Simulations', 'Forecast Gandalf', ...
        '95% theoretical interval Gandalf', '95% quantile range simulations', 'Location', 'northwest')
    ylabel('New cases')
    xlabel('Date')
    set(gcf,'color','w')
    ax = gca;
    ax.YAxis.Exponent = 3;
    set(gca,'FontSize',24)
    hold off
end

function simulations = simulate_from_Gandalf...
    (ts, days_ahead, endpoint, amount_simulations)
    gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    gandalf.Variance = garchmod;
    
    train_data = ts(1:endpoint);
    rng(123) % Set seed for reproducability
    fitted_model = estimate(gandalf, train_data, 'Display', 'off');
    [prediction, YMSE]= forecast(fitted_model, days_ahead, 'Y0', train_data);
    upper =  prediction + 1.96*sqrt(YMSE);
    lower =  prediction - 1.96*sqrt(YMSE);
    prediction = floor(exp(prediction)); 
    upper = floor(exp(upper)); 
    lower = floor(exp(lower)); 
    simulations = floor(exp(simulate(fitted_model,...
        days_ahead, 'NumPaths', amount_simulations, 'Y0', train_data)));
    % Save the results. These will be used in Python later
    writematrix(simulations.', ...
        'Matlab\Saved variables\simulations_from_gandalf.csv') 
end

function plot_loss_function(loss_func)
    %[minimum, minimum_ind] = min(loss_func); % find minimal loss and its corresponding epoc
    figure
    hold on
    loss = plot(loss_func, 'LineWidth', 3);
    yline(loss_func(100), '--', 'Mean loss after 100 epochs', ...
        'Color', 'red', 'LineWidth',2, 'LabelVerticalAlignment', 'top', 'FontSize', 24);
    ylim([-0.001 0.01])
    ylabel('Mean loss')
    xlabel('Epocs')
    set(gcf,'color','w')
    set(gca,'FontSize',24)
    hold off
end

function plot_acf_of_res(ts, endpoint, len_train, garch_noise)
    % plot ACF of residuals and squared residuals
    
    train_data = ts(endpoint-len_train+1:endpoint);
    
    mod = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    if garch_noise
        noise = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
        mod.Variance = noise
    end
    % fit model
    fitted_model = estimate(mod, train_data, 'Display','off');
    residuals = infer(fitted_model, train_data);

    % res = plot(residuals)
    [~, p_arch] = archtest(residuals, 'Lags', 2);
    %[~, p_lbq] = lbqtest(residuals);
    figure

    [acf,lags,bounds] = autocorr(residuals);
    
    stem(lags,acf, 'LineWidth',2); xlabel('Lag'); ylabel('\gamma(k)');
    
    hold on;
    h = plot(lags,bounds(1)*ones(length(acf),1), '--','LineWidth',2, 'Color',[1 0 0]);
    h1 = plot(lags,bounds(2)*ones(length(acf),1), '--' ,'LineWidth',2, 'Color',[1 0 0]);
    title([''])
    %     title(['Sample ACF of residuals of model from ',...
    %         datestr(index_to_date_norway(endpoint-len_train+1)), ' to ' datestr(index_to_date_norway(endpoint))])
    set(gcf,'color','w')
    set(gca,'FontSize',40)
    figure
    [acf,lags,bounds] = autocorr(residuals.^2);
    set(gca,'FontSize',40)
    stem(lags,acf, 'LineWidth',2); xlabel('Lag'); ylabel('\gamma(k)');
    hold on;
    h = plot(lags,bounds(1)*ones(length(acf),1), '--','LineWidth',2, 'Color',[1 0 0]);
    h1 = plot(lags,bounds(2)*ones(length(acf),1), '--' ,'LineWidth',2, 'Color',[1 0 0]);
    gtext(['P-value for Engels ARCH test: ', num2str(p_arch)],'FontSize',40) % , newline, 'P-value for Ljung-Box Q-test: ', num2str(p_lbq)]
    title([''])
    %     title(['Sample ACF of squared residuals of model from ', ...
    %         datestr(index_to_date_norway(endpoint-len_train+1)), ' to ' datestr(index_to_date_norway(endpoint))])
    set(gcf,'color','w')
    set(gca,'FontSize',40)
end

function plot_preds_sarima_gandalf...
    (ts, endpoint, len_train, days_ahead, is_global)
    % Directly predicts the next days_ahead days after endpoint
    % These are then plotted and compared to the CNN-LSTM model with the
    % same prediction sceeme

    % ts should be on log-scale

    plot_length = 14;

    sarima = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    gandalf.Variance = garchmod;

    preds_sarima = [];
    mse_sarima = [];
    preds_gandalf = [];
    mse_gandalf = [];
  
    train_data = ts(endpoint-len_train+1:endpoint);

    [fitted_sarima, ~, logL_sarima] = estimate(sarima, train_data, 'Display','off');
    [fitted_gandalf, ~, logL_gandalf]= estimate(gandalf, train_data, 'Display','off');
    [preds_sarima, mse_sarima] = forecast(fitted_sarima, days_ahead, train_data);
    [preds_gandalf, mse_gandalf] = forecast(fitted_gandalf, days_ahead, train_data);

    % Display the AICc values for both models
    [~, ~, AICc_sarima] = aicbic(logL_sarima, 3, len_train);
    [~, ~, AICc_gandalf] = aicbic(logL_gandalf, 4, len_train);
    AICc_sarima = AICc_sarima.aicc
    AICc_gandalf = AICc_gandalf.aicc

    
    % get parameter estimates
    MA_sarima = cell2mat(fitted_sarima.MA); SMA_sarima = cell2mat(fitted_sarima.SMA(7));
    sigma2 = fitted_sarima.Variance;
    round(SMA_sarima, 2)
    MA_gandalf = cell2mat(fitted_gandalf.MA); SMA_gandalf = cell2mat(fitted_gandalf.SMA(7));
    GARCH = cell2mat(fitted_gandalf.Variance.GARCH); ARCH = cell2mat(fitted_gandalf.Variance.ARCH);

    % create 95% intervals
    upper_sarima = preds_sarima + 1.96*sqrt(mse_sarima);
    lower_sarima = preds_sarima - 1.96*sqrt(mse_sarima);
    upper_gandalf = preds_gandalf + 1.96*sqrt(mse_gandalf);
    lower_gandalf =  preds_gandalf - 1.96*sqrt(mse_gandalf);

    % convert to normal scale where needed
    ts = floor(exp(ts));
    test_data = ts(endpoint+1: endpoint + days_ahead);
    preds_sarima = floor(exp(preds_sarima));preds_gandalf = floor(exp(preds_gandalf));
    upper_sarima = floor(exp(upper_sarima));lower_sarima = floor(exp(lower_sarima));
    upper_gandalf = floor(exp(upper_gandalf));lower_gandalf = floor(exp(lower_gandalf));

    % calculate RRMSE and MAPE
    RRMSE_sarima = sqrt(mean((test_data - preds_sarima).^2))/mean(test_data)*100; 
    MAPE_sarima = mean(abs(test_data - preds_sarima)./abs(test_data))*100;
    RRMSE_gandalf = sqrt(mean((test_data - preds_gandalf).^2))/mean(test_data)*100; 
    MAPE_gandalf = mean(abs(test_data - preds_gandalf)./abs(test_data))*100;

    % set dates
    if is_global
        dates_train = index_to_date_global(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_global(endpoint+1:endpoint+days_ahead);
    else 
        dates_train = index_to_date_norway(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_norway(endpoint+1:endpoint+days_ahead);
    end

    % plotting
    figure
    hold on

    data = plot(dates_train, ts(endpoint-plot_length+1:endpoint),'Color',[0.25, 0.25, 0.25]);
    obs = plot(dates_test,test_data, 'Color', [1, 0, 0],'LineWidth',3);
    predictions_sarima = plot(dates_test,preds_sarima, 'Color', [0.4940 0.1840 0.5560], 'LineWidth',2);
    u_sarima = plot(dates_test,upper_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    l_sarima = plot(dates_test,lower_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    predictions_gandalf = plot(dates_test,preds_gandalf, 'Color', [.2, .9, .5], 'LineWidth',2);
    u_gandalf = plot(dates_test,upper_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1);
    l_gandalf = plot(dates_test,lower_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1); 

    %ylim([0 1700])

    % insert percision results in plot
    set(gca,'FontSize',24)
    gtext([ ...
        '\color[rgb]{' sprintf('%f,%f,%f', [0.4940 0.1840 0.5560] ) '} SARIMA model: RRMSE = ', num2str(round(RRMSE_sarima, 2)), '%', ...
        ',  MAPE = ', num2str(round(MAPE_sarima, 2)), '%',newline, ...
        '\theta_{MA} = ', num2str(round(MA_sarima, 2)), ',  \theta_{SMA} = ', ...
        num2str(round(SMA_sarima, 2)), ',  \sigma^{2} = ', num2str(round(sigma2, 2)), newline, ...
        '\color[rgb]{' sprintf('%f,%f,%f', [.2, .9, .5]) '} Gandalf model: RRMSE = ', num2str(round(RRMSE_gandalf, 2)), '%', ...
        ',  MAPE = ', num2str(round(MAPE_gandalf, 2)), '%', newline, ...
        '\theta_{MA} = ', num2str(round(MA_gandalf, 2)), ',  \theta_{SMA} = ', ...
        num2str(round(SMA_gandalf, 2)), ',  \alpha_{1} = ', num2str(round(ARCH, 2)), ...
        ',  \beta_{1} = ', num2str(round(GARCH, 2))], 'Interpreter', 'tex','FontSize', 30);
    
    legend([data, obs, predictions_sarima, u_sarima, predictions_gandalf, u_gandalf],...
        'Training data', 'Test data', 'Forecast SARIMA','95% interval SARIMA', ...
        'Forecast Gandalf','95% interval Gandalf',  'NorthWest','FontSize', 30)
    ylabel('New cases','FontSize', 30) 
    xlabel('Date','FontSize', 30) 
    
%     if is_global
%         title(['Forecasts of Global data from ', datestr(index_to_date_global(endpoint+1)),'FontSize', 20])
%     else
%         title(['Forecasts of Norwegian data from ', datestr(index_to_date_norway(endpoint+1))],'FontSize', 20)
%     end
    set(gcf,'color','w')
    
    ax = gca;
    

    if is_global
        ax.YAxis.Exponent = 3;
    else
        ax.YAxis.Exponent = 0;
    end
    hold off
end

function plot_parameters_from_prediction_scheme_1...
    (ts, endpoint, len_train, days_ahead, is_global)
    sarima = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    gandalf.Variance = garchmod;

    preds_sarima = [];
    preds_gandalf = [];

    train_data = ts(endpoint-len_train+1:endpoint);

    % Gather initial SARIMA parameters
    fitted_sarima = estimate(sarima, train_data, 'Display','off');
    inintial_MA_sarima = round(cell2mat(fitted_sarima.MA), 4);
    inintial_SMA_sarima = round(cell2mat(fitted_sarima.SMA(7)), 4);
    inintial_SIGMA_sarima = round(fitted_sarima.Variance, 4);
        
    % Gather initial gandalf parameters
    fitted_gandalf = estimate(gandalf, train_data, 'Display','off');
    inintial_MA_gandalf = round(cell2mat(fitted_gandalf.MA), 4);
    inintial_SMA_gandalf = round(cell2mat(fitted_gandalf.SMA(7)), 4);
    inintial_ARCH_gandalf = round(cell2mat(fitted_gandalf.Variance.ARCH), 4);
    inintial_GARCH_gandalf = round(cell2mat(fitted_gandalf.Variance.GARCH), 4);

    preds_sarima = [];
    preds_gandalf = [];
    
    MA_sarima = [];
    SMA_sarima = [];
    SIGMA_sarima = [];
    MA_upper_sarima = [];
    SMA_upper_sarima = [];
    SIGMA_upper_sarima = [];
    MA_lower_sarima = [];
    SMA_lower_sarima = [];
    SIGMA_lower_sarima = [];
    MA_lower_gandalf = [];
    SMA_lower_gandalf = [];
    ARCH_lower_gandalf = [];
    GARCH_lower_gandalf = [];
    MA_gandalf = [];
    SMA_gandalf = [];
    ARCH_gandalf = [];
    GARCH_gandalf = [];
    MA_upper_gandalf = [];
    SMA_upper_gandalf = [];
    ARCH_upper_gandalf = [];
    GARCH_upper_gandalf = [];
    MA_lower_gandalf = [];
    SMA_lower_gandalf = [];
    ARCH_lower_gandalf = [];
    GARCH_lower_gandalf = [];

    for i = 1:days_ahead
        [fitted_sarima, varmat_sarima] = estimate(sarima, train_data, 'Display','off');
        [fitted_gandalf, varmat_gandalf]= estimate(gandalf, train_data, 'Display','off');

        SDs = diag(varmat_sarima).^0.5;
        SDs = SDs([2 3 4]).';
        SDs = diag(varmat_gandalf).^0.5;
        SDs = SDs([2 3 6 5]).';

        % Collect parameter estimates from SARIMA model
        MA_new_sarima = round(cell2mat(fitted_sarima.MA), 4);
        MA_sarima = [MA_sarima MA_new_sarima];
        MA_upper_sarima = [MA_upper_sarima MA_new_sarima+2*SDs(1)];
        MA_lower_sarima = [MA_lower_sarima  MA_new_sarima-2*SDs(1)];
        SMA_new_sarima = round(cell2mat(fitted_sarima.SMA(7)), 4);
        SMA_sarima = [SMA_sarima SMA_new_sarima];
        SMA_upper_sarima = [SMA_upper_sarima SMA_new_sarima+2*SDs(2)];
        SMA_lower_sarima = [SMA_lower_sarima  SMA_new_sarima-2*SDs(2)];
        SIGMA_new_sarima = round(fitted_sarima.Variance, 4);
        SIGMA_sarima = [SIGMA_sarima SIGMA_new_sarima];
        SIGMA_upper_sarima = [SIGMA_upper_sarima SIGMA_new_sarima+2*SDs(3)];
        SIGMA_lower_sarima = [SIGMA_lower_sarima  SIGMA_new_sarima-2*SDs(4)];

        % Collect parameter estimates from Gandalf model
        MA_new_gandalf = round(cell2mat(fitted_gandalf.MA), 4);
        MA_gandalf = [MA_gandalf MA_new_gandalf];
        MA_upper_gandalf = [MA_upper_gandalf MA_new_gandalf+2*SDs(1)];
        MA_lower_gandalf = [MA_lower_gandalf  MA_new_gandalf-2*SDs(1)];
        SMA_new_gandalf = round(cell2mat(fitted_gandalf.SMA(7)), 4);
        SMA_gandalf = [SMA_gandalf SMA_new_gandalf];
        SMA_upper_gandalf = [SMA_upper_gandalf SMA_new_gandalf+2*SDs(2)];
        SMA_lower_gandalf = [SMA_lower_gandalf  SMA_new_gandalf-2*SDs(2)];
        ARCH_new_gandalf = round(cell2mat(fitted_gandalf.Variance.ARCH), 4);
        ARCH_gandalf = [ARCH_gandalf ARCH_new_gandalf];
        ARCH_upper_gandalf = [ARCH_upper_gandalf ARCH_new_gandalf+2*SDs(3)];
        ARCH_lower_gandalf = [ARCH_lower_gandalf  ARCH_new_gandalf-2*SDs(4)];
        GARCH_new_gandalf = round(cell2mat(fitted_gandalf.Variance.GARCH), 4);
        GARCH_gandalf = [GARCH_gandalf GARCH_new_gandalf];
        GARCH_upper_gandalf = [GARCH_upper_gandalf GARCH_new_gandalf+2*SDs(4)];
        GARCH_lower_gandalf = [GARCH_lower_gandalf  GARCH_new_gandalf-2*SDs(4)];

        train_data = [train_data; ts(endpoint+i)]; % add next observation to training data
    end

    if is_global
        dates_test = index_to_date_global(endpoint:endpoint+days_ahead-1);
    else
        dates_test = index_to_date_norway(endpoint:endpoint+days_ahead-1);
    end

    % Plot SARIMA parameters
    figure
    subplot(2,5,[1 2])
    hold on
    ma = plot(dates_test, MA_sarima, 'Color', 'red','LineWidth',2);
    ma_upper = plot(dates_test, MA_upper_sarima,'black:','LineWidth',2);
    ma_lower = plot(dates_test, MA_lower_sarima,'black:','LineWidth',2);
    yline(inintial_MA_sarima, '--', 'Original \theta_{MA} estimate', ...
        'Color', 'red', 'LineWidth',2, 'LabelVerticalAlignment', 'bottom');
    legend([ma, ma_upper, ma_lower], '\theta_{MA}','95% confidence interval')
    ylabel('Estimated \theta_{MA}')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    hold off


    subplot(2,5, [4 5])
    hold on
    sma = plot(dates_test, SMA_sarima, 'Color', [0 1 0.7],'LineWidth',2);
    sma_upper = plot(dates_test, SMA_upper_sarima,'black:','LineWidth',2);
    sma_lower = plot(dates_test, SMA_lower_sarima,'black:','LineWidth',2);
    yline(inintial_SMA_sarima, '--', 'Original \theta_{SMA} estimate', ...
        'Color', [0 1 0.7], 'LineWidth',2, 'LabelVerticalAlignment', 'bottom');
    legend([sma sma_upper], '\theta_{SMA}','95% confidence intervall')
    ylabel('Estimated \theta_{SMA}')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    hold off

    subplot(2,5, [7 8 9])
    hold on
    sigma = plot(dates_test, SIGMA_sarima, 'Color', 'blue','LineWidth',2);
    sigma_upper = plot(dates_test, SIGMA_upper_sarima,'black:','LineWidth',2);
    sigma_lower = plot(dates_test, SIGMA_lower_sarima,'black:','LineWidth',2);
    yline(inintial_SIGMA_sarima, '--', 'Original \sigma^2 estimate', ...
        'Color', 'blue', 'LineWidth',2, 'LabelVerticalAlignment', 'bottom');
    legend([sigma sigma_upper], '\sigma^2','95% confidence intervall')
    ylabel('Estimated \sigma^2')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    hold off

    % Plot Gandalf parameters
    figure
    subplot(2,2,1)
    hold on
    ma = plot(dates_test, MA_gandalf, 'Color', 'red','LineWidth',2);
    ma_upper = plot(dates_test, MA_upper_gandalf,'black:','LineWidth',2);
    ma_lower = plot(dates_test, MA_lower_gandalf,'black:','LineWidth',2);
    yline(inintial_MA_gandalf, '--', 'Original \theta_{MA} estimate', ...
        'Color', 'red', 'LineWidth',2, 'LabelVerticalAlignment', 'bottom');
    legend([ma, ma_upper, ma_lower], '\theta_{MA}','95% confidence interval')
    ylabel('Estimated \theta_{MA}')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    hold off


    subplot(2,2,2)
    hold on
    sma = plot(dates_test, SMA_gandalf, 'Color', [0 1 0.7],'LineWidth',2);
    sma_upper = plot(dates_test, SMA_upper_gandalf,'black:','LineWidth',2);
    sma_lower = plot(dates_test, SMA_lower_gandalf,'black:','LineWidth',2);
    yline(inintial_SMA_gandalf, '--', 'Original \theta_{SMA} estimate', ...
        'Color', [0 1 0.7], 'LineWidth',2, 'LabelVerticalAlignment', 'bottom');
    legend([sma sma_upper], '\theta_{SMA}','95% confidence intervall')
    ylabel('Estimated \theta_{SMA}')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    hold off

    subplot(2,2,3)
    hold on
    arch = plot(dates_test, ARCH_gandalf, 'Color', 'blue','LineWidth',2);
    arch_upper = plot(dates_test, ARCH_upper_gandalf,'black:','LineWidth',2);
    arch_lower = plot(dates_test, ARCH_lower_gandalf,'black:','LineWidth',2);
    yline(inintial_ARCH_gandalf, '--', 'Original \alpha_{1} estimate', ...
        'Color', 'blue', 'LineWidth',2, 'LabelVerticalAlignment', 'bottom');
    legend([arch arch_upper], '\alpha_{1}','95% confidence intervall')
    ylabel('Estimated \alpha_{1}')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    hold off

    subplot(2,2,4)
    hold on
    garch_plot = plot(dates_test, GARCH_gandalf, 'Color', 'green','LineWidth',2);
    garch_upper = plot(dates_test, GARCH_upper_gandalf,'black:','LineWidth',2);
    garch_lower = plot(dates_test, GARCH_lower_gandalf,'black:','LineWidth',2);
    yline(inintial_GARCH_gandalf, '--', 'Original \beta_{1} estimate', ...
        'Color', 'green', 'LineWidth',2, 'LabelVerticalAlignment', 'bottom');
    legend([garch_plot garch_upper], '\beta_{1}','95% confidence intervall')
    ylabel('Estimated \beta_{1}')
    xlabel('Date')
    set(gcf,'Color','w')
    set(gca,'FontSize',24)
    hold off
end

function plot_all_predictions_with_observed...
    (ts, preds_cnn, endpoint, len_train, days_ahead, is_global)
    % Plots the two previous functions in the same figure
    % ts is on log-scale
    plot_length = 14;
    sarima = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    gandalf.Variance = garchmod;

    preds_sarima = [];
    mse_sarima = [];
    preds_gandalf = [];
    mse_gandalf = [];
  
    train_data = ts(endpoint-len_train+1:endpoint);
    for i = 1:days_ahead
        fitted_sarima = estimate(sarima, train_data, 'Display','off');
        fitted_gandalf= estimate(gandalf, train_data, 'Display','off');
        [preds_sarima(end+1), mse_sarima(end+1)] = ...
            forecast(fitted_sarima, 1, train_data);
        [preds_gandalf(end+1), mse_gandalf(end+1)] = ...
            forecast(fitted_gandalf, 1, train_data);
        % add next observation to training data:
        train_data = [train_data; ts(endpoint+i)]; 
    end
    
    mean_preds_cnn = mean(preds_cnn, 1);
    %mse_cnn = mse_cnn_lstm(ts, mean_preds_cnn, endpoint, len_train, true);   

    % create 95% intervals
    upper_sarima = preds_sarima + 1.96*sqrt(mse_sarima);
    lower_sarima = preds_sarima - 1.96*sqrt(mse_sarima);
    upper_gandalf = preds_gandalf + 1.96*sqrt(mse_gandalf);
    lower_gandalf =  preds_gandalf - 1.96*sqrt(mse_gandalf);
    %upper_cnn = mean_preds_cnn + 1.96*round(sqrt(mse_cnn));
    %lower_cnn = mean_preds_cnn - 1.96*round(sqrt(mse_cnn));

    % convert to normal scale where needed
    ts = floor(exp(ts));
    test_data = ts(endpoint+1: endpoint + days_ahead);
    preds_sarima = floor(exp(preds_sarima));preds_gandalf = ...
        floor(exp(preds_gandalf));
    upper_sarima = floor(exp(upper_sarima));lower_sarima = ...
        floor(exp(lower_sarima));
    upper_gandalf = floor(exp(upper_gandalf));lower_gandalf = ...
        floor(exp(lower_gandalf));

    % calculate RRMSE and MAPE for single predictions
    RRMSE_sarima = ...
        sqrt(mean((test_data - preds_sarima).^2))/mean(test_data)*100; 
    MAPE_sarima = ...
        mean(abs(test_data - preds_sarima)./abs(test_data))*100;
    RRMSE_gandalf = ...
        sqrt(mean((test_data - preds_gandalf).^2))/mean(test_data)*100; 
    MAPE_gandalf = ...
        mean(abs(test_data - preds_gandalf)./abs(test_data))*100;
    RRMSE_cnn = ...
        sqrt(mean((test_data - mean_preds_cnn.').^2))/mean(test_data)*100; 
    MAPE_cnn = ...
        mean(abs(test_data - mean_preds_cnn.')./abs(test_data))*100;

    % calculate RRMAE and MAPE for the 10 CNN-LSTM models
    RRMSE = zeros(10, 1);
    MAPE = zeros(10, 1);
    for i = 1:10
        RRMSE(i) = sqrt(mean((test_data.' - preds_cnn(i, :)).^2))/...
            mean(test_data)*100; 
        MAPE(i) = mean(abs(test_data.' - preds_cnn(i, :))./...
            abs(test_data.'))*100;
    end

    % set dates
    if is_global
        dates_train = index_to_date_global(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_global(endpoint+1:endpoint+days_ahead);
    else 
        dates_train = index_to_date_norway(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_norway(endpoint+1:endpoint+days_ahead);
    end
    % generate RGB colors for plot for the 10 CNN-LSTM models 
    rng(1234)
    cols = [];
    for i = 1:10
    c = [rand, rand, rand];
    cols = [cols; c];
    end

    % plotting
    figure
    set(gca,'FontSize',24)
    subplot(1,2,1)
    hold on
    data = plot(dates_train, ts(endpoint-plot_length+1:endpoint),...
        'Color',[0.25, 0.25, 0.25]);
    obs = plot(dates_test, test_data, 'Color', [1 0 0],'LineWidth',3);
    pred1 = plot(dates_test,preds_cnn(1, :), 'Color', cols(1, :), 'LineWidth',1);
    pred2 = plot(dates_test,preds_cnn(2, :), 'Color', cols(2, :), 'LineWidth',1);
    pred3 = plot(dates_test,preds_cnn(3, :), 'Color', cols(3, :), 'LineWidth',1);
    pred4 = plot(dates_test,preds_cnn(4, :), 'Color', cols(4, :), 'LineWidth',1);
    pred5 = plot(dates_test,preds_cnn(5, :), 'Color', cols(5, :), 'LineWidth',1);
    pred6 = plot(dates_test,preds_cnn(6, :), 'Color', cols(6, :), 'LineWidth',1);
    pred7 = plot(dates_test,preds_cnn(7, :), 'Color', cols(7, :), 'LineWidth',1);
    pred8 = plot(dates_test,preds_cnn(8, :), 'Color', cols(8, :), 'LineWidth',1);
    pred9 = plot(dates_test,preds_cnn(9, :), 'Color', cols(9, :), 'LineWidth',1);
    pred10 = plot(dates_test,preds_cnn(10, :), 'Color', cols(10, :), 'LineWidth',1);

    gtext([ ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(1,:) ) '} Model 1: RRMSE = ', num2str(round(RRMSE(1), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(1), 2)), '%',newline, ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(2,:) ) '} Model 2: RRMSE = ', num2str(round(RRMSE(2), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(2), 2)), '%',newline, ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(3,:) ) '} Model 3: RRMSE = ', num2str(round(RRMSE(3), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(3), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(4,:) ) '} Model 4: RRMSE = ', num2str(round(RRMSE(4), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(4), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(5,:) ) '} Model 5: RRMSE = ', num2str(round(RRMSE(5), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(5), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(6,:) ) '} Model 6: RRMSE = ', num2str(round(RRMSE(6), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(6), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(7,:) ) '} Model 7: RRMSE = ', num2str(round(RRMSE(7), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(7), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(8,:) ) '} Model 8: RRMSE = ', num2str(round(RRMSE(8), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(8), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(9,:) ) '} Model 9: RRMSE = ', num2str(round(RRMSE(9), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(9), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(10,:) ) '} Model 10: RRMSE = ', num2str(round(RRMSE(10), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(10), 2))], 'Interpreter', 'tex','FontSize', 30);

    gtext(['Mean RRMSE = ', num2str(round(mean(RRMSE), 2)), '%',', mean MAPE = ', num2str(round(mean(MAPE), 2)), '%'],'FontSize', 30)
    
    legend([data, obs], 'Training data', 'Test data', 'NorthWest','FontSize', 30)
    ylabel('New cases') 
    xlabel('Date') 
    if is_global
        title(['Forcast with 10 CNN-LSTM models on Global data from ', datestr(index_to_date_global(endpoint+1)),...
        ' with sample size ', num2str(len_train), ' and nessesary observed data'],'FontSize', 60)
    else
        title(['Forcast with 10 CNN-LSTM models on Norwegian data from ', datestr(index_to_date_norway(endpoint+1)),...
        ' with sample size ', num2str(len_train), ' and nessesary observed data'],'FontSize', 60)
    end
    ax = gca;
    ax.YAxis.Exponent = 3;
    set(gca,'FontSize',20)
    hold off
   
    subplot(1,2,2)
    hold on
    data = plot(dates_train, ts(endpoint-plot_length+1:endpoint),'Color',[0.25, 0.25, 0.25]);
    obs = plot(dates_test,test_data, 'Color', [1, 0, 0],'LineWidth',3);
    predictions_sarima = plot(dates_test,preds_sarima, 'Color', [0.4940 0.1840 0.5560], 'LineWidth',2);
    u_sarima = plot(dates_test,upper_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    l_sarima = plot(dates_test,lower_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    predictions_gandalf = plot(dates_test,preds_gandalf, 'Color', [.2, .9, .5], 'LineWidth',2);
    u_gandalf = plot(dates_test,upper_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1);
    l_gandalf = plot(dates_test,lower_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1); 
    predictions_cnn = plot(dates_test,mean_preds_cnn, 'Color', [0 0.4470 0.7410], 'LineWidth',2);
    %u_cnn = plot(dates_test,upper_cnn, '--', 'Color', [0 0.4470 0.7410], 'LineWidth',1);
    %l_cnn = plot(dates_test,lower_cnn, '--', 'Color', [0 0.4470 0.7410], 'LineWidth',1); 

    ylim([0 800000])

    % insert percision results in plot
    gtext([ ...
        '\color[rgb]{' sprintf('%f,%f,%f', [0.4940 0.1840 0.5560] ) '} SARIMA model: RRMSE = ', num2str(round(RRMSE_sarima, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_sarima, 2)), '%',newline, ...
        '\color[rgb]{' sprintf('%f,%f,%f', [.2, .9, .5]) '} Gandalf model: RRMSE = ', num2str(round(RRMSE_gandalf, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_gandalf, 2)), '%', newline, ...
        '\color[rgb]{' sprintf('%f,%f,%f', [0 0.4470 0.7410]) '} CNN-LSTM model: RRMSE = ', num2str(round(RRMSE_cnn, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_cnn, 2)), '%',
        ], 'Interpreter', 'tex','FontSize', 30);

    legend([data, obs, predictions_sarima, u_sarima, predictions_gandalf, u_gandalf, predictions_cnn, u_cnn],...
        'Training data', 'Test data', 'Forecast SARIMA','95% interval SARIMA', ...
        'Forecast Gandalf','95% interval Gandalf', 'Forecast CNN-LSTM',  'NorthWest','FontSize', 30) % '95% interval CNN-LSTM',
    ylabel('New cases','FontSize', 30) 
    xlabel('Date','FontSize', 30) 
    if is_global
        title(['Forecasts of Global data from ', datestr(index_to_date_global(endpoint+1)), ...
            ' using only one-step predictions with observed values'],'FontSize', 30)
    else 
        title(['Forecasts of Norwegian data from ', datestr(index_to_date_norway(endpoint+1)), ...
            ' using only one-step predictions with observed values'],'FontSize', 30)
    end
    set(gcf,'color','w')
    set(gca,'FontSize',20)
    ax = gca;
    ax.YAxis.Exponent = 3;
    if is_global
        ax.YAxis.Exponent = 3;
    else
        ax.YAxis.Exponent = 0;
    end
    hold off
end

function plot_all_predictions_without_observed(ts, preds_cnn, endpoint, len_train, days_ahead, is_global)
    % Plots the two previous functions in the same figure
    % ts is on log-scale
    plot_length = 14;
    sarima = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    gandalf.Variance = garchmod;

    %[sarima_1, ~, logL_without] = estimate(mod, ts_train, 'Display','off');

    preds_sarima = [];
    mse_sarima = [];
    preds_gandalf = [];
    mse_gandalf = [];
  
    train_data = ts(endpoint-len_train+1:endpoint);

    tic
    fitted_sarima = estimate(sarima, train_data, 'Display','off');
    fitted_gandalf= estimate(gandalf, train_data, 'Display','off');
    [preds_sarima, mse_sarima] = forecast(fitted_sarima, days_ahead, train_data);
    [preds_gandalf, mse_gandalf] = forecast(fitted_gandalf, days_ahead, train_data);
    toc
    
    mean_preds_cnn = mean(preds_cnn, 1);
    %mse_cnn = mse_cnn_lstm(ts, mean_preds_cnn, endpoint, len_train, false);   

    % create 95% intervals
    upper_sarima = preds_sarima + 1.96*sqrt(mse_sarima);
    lower_sarima = preds_sarima - 1.96*sqrt(mse_sarima);
    upper_gandalf = preds_gandalf + 1.96*sqrt(mse_gandalf);
    lower_gandalf =  preds_gandalf - 1.96*sqrt(mse_gandalf);
    %upper_cnn = mean_preds_cnn + 1.96*round(sqrt(mse_cnn));
    %lower_cnn = mean_preds_cnn - 1.96*round(sqrt(mse_cnn));

    % convert to normal scale where needed
    ts = floor(exp(ts));
    test_data = ts(endpoint+1: endpoint + days_ahead);
    preds_sarima = floor(exp(preds_sarima));preds_gandalf = floor(exp(preds_gandalf));
    upper_sarima = floor(exp(upper_sarima));lower_sarima = floor(exp(lower_sarima));
    upper_gandalf = floor(exp(upper_gandalf));lower_gandalf = floor(exp(lower_gandalf));

    % calculate RRMSE and MAPE for single predictions
    RRMSE_sarima = sqrt(mean((test_data - preds_sarima).^2))/mean(test_data)*100; 
    MAPE_sarima = mean(abs(test_data - preds_sarima)./abs(test_data))*100;
    RRMSE_gandalf = sqrt(mean((test_data - preds_gandalf).^2))/mean(test_data)*100; 
    MAPE_gandalf = mean(abs(test_data - preds_gandalf)./abs(test_data))*100;
    RRMSE_cnn = sqrt(mean((test_data - mean_preds_cnn.').^2))/mean(test_data)*100; 
    MAPE_cnn = mean(abs(test_data - mean_preds_cnn.')./abs(test_data))*100;

    % calculate RRMAE and MAPE for the 10 CNN-LSTM models
    RRMSE = zeros(10, 1);
    MAPE = zeros(10, 1);
    for i = 1:10
        RRMSE(i) = sqrt(mean((test_data.' - preds_cnn(i, :)).^2))/mean(test_data)*100; 
        MAPE(i) = mean(abs(test_data.' - preds_cnn(i, :))./abs(test_data.'))*100;
    end

    % set dates
    if is_global
        dates_train = index_to_date_global(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_global(endpoint+1:endpoint+days_ahead);
    else 
        dates_train = index_to_date_norway(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_norway(endpoint+1:endpoint+days_ahead);
    end
    

    % generate RGB colors for plot for the 10 CNN-LSTM models 
    rng(1234)
    cols = [];
    for i = 1:10
    c = [rand, rand, rand];
    cols = [cols; c];
    end

    % plotting
    figure
    set(gca,'FontSize',24)
    subplot(1,2,1)
    hold on
    data = plot(dates_train, ts(endpoint-plot_length+1:endpoint),'Color',[0.25, 0.25, 0.25]);
    obs = plot(dates_test, test_data, 'Color', [1 0 0],'LineWidth',3);
    pred1 = plot(dates_test,preds_cnn(1, :), 'Color', cols(1, :), 'LineWidth',1);
    pred2 = plot(dates_test,preds_cnn(2, :), 'Color', cols(2, :), 'LineWidth',1);
    pred3 = plot(dates_test,preds_cnn(3, :), 'Color', cols(3, :), 'LineWidth',1);
    pred4 = plot(dates_test,preds_cnn(4, :), 'Color', cols(4, :), 'LineWidth',1);
    pred5 = plot(dates_test,preds_cnn(5, :), 'Color', cols(5, :), 'LineWidth',1);
    pred6 = plot(dates_test,preds_cnn(6, :), 'Color', cols(6, :), 'LineWidth',1);
    pred7 = plot(dates_test,preds_cnn(7, :), 'Color', cols(7, :), 'LineWidth',1);
    pred8 = plot(dates_test,preds_cnn(8, :), 'Color', cols(8, :), 'LineWidth',1);
    pred9 = plot(dates_test,preds_cnn(9, :), 'Color', cols(9, :), 'LineWidth',1);
    pred10 = plot(dates_test,preds_cnn(10, :), 'Color', cols(10, :), 'LineWidth',1);

    gtext([ ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(1,:) ) '} Model 1: RRMSE = ', num2str(round(RRMSE(1), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(1), 2)), '%',newline, ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(2,:) ) '} Model 2: RRMSE = ', num2str(round(RRMSE(2), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(2), 2)), '%',newline, ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(3,:) ) '} Model 3: RRMSE = ', num2str(round(RRMSE(3), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(3), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(4,:) ) '} Model 4: RRMSE = ', num2str(round(RRMSE(4), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(4), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(5,:) ) '} Model 5: RRMSE = ', num2str(round(RRMSE(5), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(5), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(6,:) ) '} Model 6: RRMSE = ', num2str(round(RRMSE(6), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(6), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(7,:) ) '} Model 7: RRMSE = ', num2str(round(RRMSE(7), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(7), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(8,:) ) '} Model 8: RRMSE = ', num2str(round(RRMSE(8), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(8), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(9,:) ) '} Model 9: RRMSE = ', num2str(round(RRMSE(9), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(9), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(10,:) ) '} Model 10: RRMSE = ', num2str(round(RRMSE(10), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(10), 2))], 'Interpreter', 'tex','FontSize', 30);

    gtext(['Mean RRMSE = ', num2str(round(mean(RRMSE), 2)), '%',', mean MAPE = ', num2str(round(mean(MAPE), 2)), '%'],'FontSize', 30)
    
    legend([data, obs], 'Training data', 'Test data', 'NorthWest','FontSize', 30)
    ylabel('New cases','FontSize', 30) 
    xlabel('Date','FontSize', 30) 
    if is_global
        title(['Forcast with 10 CNN-LSTM models on Global data from ', datestr(index_to_date_global(endpoint+1)),...
        ' with sample size ', num2str(len_train)],'FontSize', 30)
    else
        title(['Forcast with 10 CNN-LSTM models on Norwegian data from ', datestr(index_to_date_norway(endpoint+1)),...
        ' with sample size ', num2str(len_train)],'FontSize', 30)
    end
    ax = gca;
    ax.YAxis.Exponent = 3;
    set(gca,'FontSize',20)
    hold off
   
    subplot(1,2,2)
    hold on
    data = plot(dates_train, ts(endpoint-plot_length+1:endpoint),'Color',[0.25, 0.25, 0.25]);
    obs = plot(dates_test,test_data, 'Color', [1, 0, 0],'LineWidth',3);
    predictions_sarima = plot(dates_test,preds_sarima, 'Color', [0.4940 0.1840 0.5560], 'LineWidth',2);
    u_sarima = plot(dates_test,upper_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    l_sarima = plot(dates_test,lower_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    predictions_gandalf = plot(dates_test,preds_gandalf, 'Color', [.2, .9, .5], 'LineWidth',2);
    u_gandalf = plot(dates_test,upper_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1);
    l_gandalf = plot(dates_test,lower_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1); 
    predictions_cnn = plot(dates_test,mean_preds_cnn, 'Color', [0 0.4470 0.7410], 'LineWidth',2);
    %u_cnn = plot(dates_test,upper_cnn, '--', 'Color', [0 0.4470 0.7410], 'LineWidth',1);
    %l_cnn = plot(dates_test,lower_cnn, '--', 'Color', [0 0.4470 0.7410], 'LineWidth',1); 

    ylim([0 800000])

    % insert percision results in plot
    gtext([ ...
        '\color[rgb]{' sprintf('%f,%f,%f', [0.4940 0.1840 0.5560] ) '} SARIMA model: RRMSE = ', num2str(round(RRMSE_sarima, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_sarima, 2)), '%',newline, ...
        '\color[rgb]{' sprintf('%f,%f,%f', [.2, .9, .5]) '} Gandalf model: RRMSE = ', num2str(round(RRMSE_gandalf, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_gandalf, 2)), '%', newline, ...
        '\color[rgb]{' sprintf('%f,%f,%f', [0 0.4470 0.7410]) '} CNN-LSTM model: RRMSE = ', num2str(round(RRMSE_cnn, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_cnn, 2)), '%',
        ], 'Interpreter', 'tex','FontSize', 30);

    legend([data, obs, predictions_sarima, u_sarima, predictions_gandalf, u_gandalf, predictions_cnn],...
        'Training data', 'Test data', 'Forecast SARIMA','95% interval SARIMA', ...
        'Forecast Gandalf','95% interval Gandalf', 'Forecast CNN-LSTM',  'NorthWest','FontSize', 30)
    ylabel('New cases','FontSize', 30) 
    xlabel('Date','FontSize', 30) 
    if is_global
        title(['Forecasts of Global data from ', datestr(index_to_date_global(endpoint+1)),' with sample size ', num2str(len_train)],'FontSize', 30)
    else 
        title(['Forecasts of Norwegian data from ', datestr(index_to_date_norway(endpoint+1)), ' with sample size ', num2str(len_train)],'FontSize', 30)
    end
    set(gcf,'color','w')
    ax = gca;
    if is_global
        ax.YAxis.Exponent = 3;
    else
        ax.YAxis.Exponent = 0;
    end
    axis off
    hold off
end

function plot_10_norway_CNN_LSTM_Preds(ts, preds, endpoint, len_train, days_ahead, use_observed)
    % Plot the results from all 10 CNN-LSTM models
    % preds = 10 days_ahead forecasts
    % use_observed should be true if observations are used to predict the
    % ensuing day
    plot_length = 14;
    test_data = ts(endpoint+1: endpoint + days_ahead);
    % calculate RRMSE, MAE and OSRE 
    RRMSE = zeros(10, 1);
    MAPE = zeros(10, 1);
    for i = 1:10
        RRMSE(i) = sqrt(mean((test_data.' - preds(i, :)).^2))/mean(test_data)*100; 
        MAPE(i) = mean(abs(test_data.' - preds(i, :))./abs(test_data.'))*100;
    end
    
    dates_train = index_to_date_norway(endpoint-plot_length+1:endpoint);
    dates_test = index_to_date_norway(endpoint+1:endpoint+days_ahead);
    

    % generate RGB colors for plot
    rng(1234)
    cols = [];
    for i = 1:10
    c = [rand, rand, rand];
    cols = [cols; c];
    end
    figure
    hold on

    data = plot(dates_train, ts(endpoint-plot_length+1:endpoint),'Color',[0.25, 0.25, 0.25]);
    obs = plot(dates_test, test_data, 'Color', [1 0 0],'LineWidth',3);
    pred1 = plot(dates_test,preds(1, :), 'Color', cols(1, :), 'LineWidth',1);
    pred2 = plot(dates_test,preds(2, :), 'Color', cols(2, :), 'LineWidth',1);
    pred3 = plot(dates_test,preds(3, :), 'Color', cols(3, :), 'LineWidth',1);
    pred4 = plot(dates_test,preds(4, :), 'Color', cols(4, :), 'LineWidth',1);
    pred5 = plot(dates_test,preds(5, :), 'Color', cols(5, :), 'LineWidth',1);
    pred6 = plot(dates_test,preds(6, :), 'Color', cols(6, :), 'LineWidth',1);
    pred7 = plot(dates_test,preds(7, :), 'Color', cols(7, :), 'LineWidth',1);
    pred8 = plot(dates_test,preds(8, :), 'Color', cols(8, :), 'LineWidth',1);
    pred9 = plot(dates_test,preds(9, :), 'Color', cols(9, :), 'LineWidth',1);
    pred10 = plot(dates_test,preds(10, :), 'Color', cols(10, :), 'LineWidth',1);
    
    set(gca,'FontSize',24)
    gtext([ ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(1,:) ) '} Model 1: RRMSE = ', num2str(round(RRMSE(1), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(1), 2)), '%',newline, ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(2,:) ) '} Model 2: RRMSE = ', num2str(round(RRMSE(2), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(2), 2)), '%',newline, ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(3,:) ) '} Model 3: RRMSE = ', num2str(round(RRMSE(3), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(3), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(4,:) ) '} Model 4: RRMSE = ', num2str(round(RRMSE(4), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(4), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(5,:) ) '} Model 5: RRMSE = ', num2str(round(RRMSE(5), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(5), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(6,:) ) '} Model 6: RRMSE = ', num2str(round(RRMSE(6), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(6), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(7,:) ) '} Model 7: RRMSE = ', num2str(round(RRMSE(7), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(7), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(8,:) ) '} Model 8: RRMSE = ', num2str(round(RRMSE(8), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(8), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(9,:) ) '} Model 9: RRMSE = ', num2str(round(RRMSE(9), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(9), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(10,:) ) '} Model 10: RRMSE = ', num2str(round(RRMSE(10), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(10), 2))], 'Interpreter', 'tex','FontSize', 30);

    gtext(['Mean RRMSE = ', num2str(round(mean(RRMSE), 2)), '%',', mean MAPE = ', num2str(round(mean(MAPE), 2)), '%'],'FontSize', 30)
    
    legend([data, obs], 'Training data', 'Test data', 'NorthWest','FontSize', 30)
    
    ylabel('New cases','FontSize', 30) 
    xlabel('Date','FontSize', 30) 
    if use_observed
        title(['Predictions\Forcast with 10 CNN-LSTM models on Norwegian data from ', datestr(index_to_date_norway(endpoint+1)),...
        ' using the ', num2str(len_train), ' previous days and observations'],'FontSize', 30)
    else 
        title(['Predictions\Forcast with 10 CNN-LSTM models on Norwegian data from ', datestr(index_to_date_norway(endpoint+1)),...
        ' using the ', num2str(len_train), ' previous days'],'FontSize', 30)
    end
    set(gcf,'color','w')
    set(gca,'FontSize',20)
    ax = gca;
    ax.YAxis.Exponent = 0;
    hold off
end

function plot_10_global_CNN_LSTM_Preds(ts, preds, endpoint, len_train, days_ahead, use_observed)
    % Plot the results from all 10 CNN-LSTM models
    % preds = 10 days_ahead forecasts
    % use_observed should be true if observations are used to predict the
    % ensuing day
    plot_length = 30;
    test_data = ts(endpoint+1: endpoint + days_ahead);
    % calculate RRMSE, MAE and OSRE 
    RRMSE = zeros(10, 1);
    MAPE = zeros(10, 1);
    for i = 1:10
        RRMSE(i) = sqrt(mean((test_data.' - preds(i, :)).^2))/mean(test_data)*100; 
        MAPE(i) = mean(abs(test_data.' - preds(i, :))./abs(test_data.'))*100;
    end
    
    dates_train = index_to_date_global(endpoint-plot_length+1:endpoint);
    dates_test = index_to_date_global(endpoint+1:endpoint+days_ahead);
    

    % generate RGB colors for plot
    rng(1234)
    cols = [];
    for i = 1:10
    c = [rand, rand, rand];
    cols = [cols; c];
    end
    figure
    hold on

    data = plot(dates_train, ts(endpoint-plot_length+1:endpoint),'Color',[0.25, 0.25, 0.25]);
    obs = plot(dates_test, test_data, 'Color', [1 0 0],'LineWidth',3);
    pred1 = plot(dates_test,preds(1, :), 'Color', cols(1, :), 'LineWidth',1);
    pred2 = plot(dates_test,preds(2, :), 'Color', cols(2, :), 'LineWidth',1);
    pred3 = plot(dates_test,preds(3, :), 'Color', cols(3, :), 'LineWidth',1);
    pred4 = plot(dates_test,preds(4, :), 'Color', cols(4, :), 'LineWidth',1);
    pred5 = plot(dates_test,preds(5, :), 'Color', cols(5, :), 'LineWidth',1);
    pred6 = plot(dates_test,preds(6, :), 'Color', cols(6, :), 'LineWidth',1);
    pred7 = plot(dates_test,preds(7, :), 'Color', cols(7, :), 'LineWidth',1);
    pred8 = plot(dates_test,preds(8, :), 'Color', cols(8, :), 'LineWidth',1);
    pred9 = plot(dates_test,preds(9, :), 'Color', cols(9, :), 'LineWidth',1);
    pred10 = plot(dates_test,preds(10, :), 'Color', cols(10, :), 'LineWidth',1);
    
    set(gca,'FontSize',24)
    gtext([ ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(1,:) ) '} Model 1: RRMSE = ', num2str(round(RRMSE(1), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(1), 2)), '%',newline, ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(2,:) ) '} Model 2: RRMSE = ', num2str(round(RRMSE(2), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(2), 2)), '%',newline, ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(3,:) ) '} Model 3: RRMSE = ', num2str(round(RRMSE(3), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(3), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(4,:) ) '} Model 4: RRMSE = ', num2str(round(RRMSE(4), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(4), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(5,:) ) '} Model 5: RRMSE = ', num2str(round(RRMSE(5), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(5), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(6,:) ) '} Model 6: RRMSE = ', num2str(round(RRMSE(6), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(6), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(7,:) ) '} Model 7: RRMSE = ', num2str(round(RRMSE(7), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(7), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(8,:) ) '} Model 8: RRMSE = ', num2str(round(RRMSE(8), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(8), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(9,:) ) '} Model 9: RRMSE = ', num2str(round(RRMSE(9), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(9), 2)), '%',newline ...
    '\color[rgb]{' sprintf('%f,%f,%f', cols(10,:) ) '} Model 10: RRMSE = ', num2str(round(RRMSE(10), 2)), '%', ...
    ', MAPE = ', num2str(round(MAPE(10), 2))], 'Interpreter', 'tex','FontSize', 30);

    gtext(['Mean RRMSE = ', num2str(round(mean(RRMSE), 2)), '%',', mean MAPE = ', num2str(round(mean(MAPE), 2)), '%'],'FontSize', 30)
    
    legend([data, obs], 'Training data', 'Test data', 'NorthWest','FontSize', 30)
    
    ylabel('New cases','FontSize', 30) 
    xlabel('Date','FontSize', 30) 
    if use_observed
        title(['Predictions\Forcast with 10 CNN-LSTM models on Global data from ', datestr(index_to_date_global(endpoint+1)),...
        ' using the ', num2str(len_train), ' previous days and observations'],'FontSize', 30)
    else 
        title(['Predictions\Forcast with 10 CNN-LSTM models on Global data from ', datestr(index_to_date_global(endpoint+1)),...
        ' using the ', num2str(len_train), ' previous days'],'FontSize', 30)
    end
    set(gcf,'color','w')
    set(gca,'FontSize',20)
    ax = gca;
    ax.YAxis.Exponent = 3;
    hold off
end

function plot_preds_without_observed(ts, preds_cnn, endpoint, len_train, days_ahead, is_global, plot_length)
    % Directly predicts the next days_ahead days after endpoint
    % These are then plotted and compared to the CNN-LSTM model with the
    % same prediction sceeme

    % ts should be on log-scale
    % preds_cnn should not use observed values after training to forecast


    sarima = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    gandalf.Variance = garchmod;

    %[sarima_1, ~, logL_without] = estimate(mod, ts_train, 'Display','off');

    preds_sarima = [];
    mse_sarima = [];
    preds_gandalf = [];
    mse_gandalf = [];
  
    train_data = ts(endpoint-len_train+1:endpoint);

    tic
    fitted_sarima = estimate(sarima, train_data, 'Display','off');
    fitted_gandalf= estimate(gandalf, train_data, 'Display','off');
    [preds_sarima, mse_sarima] = forecast(fitted_sarima, days_ahead, train_data);
    [preds_gandalf, mse_gandalf] = forecast(fitted_gandalf, days_ahead, train_data);
    toc

    %mse_cnn = mse_cnn_lstm(ts, preds_cnn, endpoint, len_train, false);   

    % create 95% intervals
    upper_sarima = preds_sarima + 1.96*sqrt(mse_sarima);
    lower_sarima = preds_sarima - 1.96*sqrt(mse_sarima);
    upper_gandalf = preds_gandalf + 1.96*sqrt(mse_gandalf);
    lower_gandalf =  preds_gandalf - 1.96*sqrt(mse_gandalf);
    %upper_cnn = preds_cnn + 1.96*round(sqrt(mse_cnn));
    %lower_cnn = preds_cnn - 1.96*round(sqrt(mse_cnn));

    % convert to normal scale where needed
    ts = floor(exp(ts));
    test_data = ts(endpoint+1: endpoint + days_ahead);
    preds_sarima = floor(exp(preds_sarima));preds_gandalf = floor(exp(preds_gandalf));
    upper_sarima = floor(exp(upper_sarima));lower_sarima = floor(exp(lower_sarima));
    upper_gandalf = floor(exp(upper_gandalf));lower_gandalf = floor(exp(lower_gandalf));

    % calculate RRMSE and MAPE
    RRMSE_sarima = sqrt(mean((test_data - preds_sarima).^2))/mean(test_data)*100; 
    MAPE_sarima = mean(abs(test_data - preds_sarima)./abs(test_data))*100;
    RRMSE_gandalf = sqrt(mean((test_data - preds_gandalf).^2))/mean(test_data)*100; 
    MAPE_gandalf = mean(abs(test_data - preds_gandalf)./abs(test_data))*100;
    RRMSE_cnn = sqrt(mean((test_data - preds_cnn.').^2))/mean(test_data)*100; 
    MAPE_cnn = mean(abs(test_data - preds_cnn.')./abs(test_data))*100;

    % set dates
    if is_global
        dates_train = index_to_date_global(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_global(endpoint+1:endpoint+days_ahead);
    else
        dates_train = index_to_date_norway(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_norway(endpoint+1:endpoint+days_ahead);
    end

    % plotting
    figure
    set(gca,'FontSize',24)
    hold on
    
    data = plot(dates_train, ts(endpoint-plot_length+1:endpoint),'Color',[0.25, 0.25, 0.25]);
    obs = plot(dates_test,test_data, 'Color', [1, 0, 0],'LineWidth',3);
    predictions_sarima = plot(dates_test,preds_sarima, 'Color', [0.4940 0.1840 0.5560], 'LineWidth',2);
    u_sarima = plot(dates_test,upper_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    l_sarima = plot(dates_test,lower_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    predictions_gandalf = plot(dates_test,preds_gandalf, 'Color', [.2, .9, .5], 'LineWidth',2);
    u_gandalf = plot(dates_test,upper_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1);
    l_gandalf = plot(dates_test,lower_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1); 
    predictions_cnn = plot(dates_test,preds_cnn, 'Color', [0 0.4470 0.7410], 'LineWidth',2);
    %u_cnn = plot(dates_test,upper_cnn, '--', 'Color', [0 0.4470 0.7410], 'LineWidth',1);
    %l_cnn = plot(dates_test,lower_cnn, '--', 'Color', [0 0.4470 0.7410], 'LineWidth',1); 

    %ylim([0 700000])

    % insert percision results in plot
    gtext([ ...
        '\color[rgb]{' sprintf('%f,%f,%f', [0.4940 0.1840 0.5560] ) '} SARIMA model: RRMSE = ', num2str(round(RRMSE_sarima, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_sarima, 2)), '%',newline, ...
        '\color[rgb]{' sprintf('%f,%f,%f', [.2, .9, .5]) '} Gandalf model: RRMSE = ', num2str(round(RRMSE_gandalf, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_gandalf, 2)), '%', newline, ...
        '\color[rgb]{' sprintf('%f,%f,%f', [0 0.4470 0.7410]) '} CNN-LSTM model: RRMSE = ', num2str(round(RRMSE_cnn, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_cnn, 2)), '%',
        ], 'Interpreter', 'tex','FontSize', 30);

    legend([data, obs, predictions_sarima, u_sarima, predictions_gandalf, u_gandalf, predictions_cnn],...
        'Training data', 'Test data', 'Forecast SARIMA','95% interval SARIMA', ...
        'Forecast Gandalf','95% interval Gandalf', 'Forecast CNN-LSTM',  'NorthWest','FontSize', 30) % '95% interval CNN-LSTM',
    ylabel('New cases','FontSize', 30) 
    xlabel('Date','FontSize', 30) 
%     if is_global
%         title(['Forecasts of Global data from ', datestr(index_to_date_global(endpoint+1))],'FontSize', 30)
%     else
%       title(['Forecasts of Norwegian data from ', datestr(index_to_date_norway(endpoint+1))],'FontSize', 30)
%     end
    set(gcf,'color','w')
    set(gca,'FontSize',20)
    ax = gca;
    
    if is_global
        ax.YAxis.Exponent = 3;
    else
        ax.YAxis.Exponent = 0;
       
    end
    hold off
end

function plot_preds_with_observed(ts, preds_cnn, endpoint, len_train, days_ahead, is_global, plot_length)
    % performes a series of one step predictions for the SARIMA model and
    % the Gandalf model, where the next observation is included as train
    % data. 
    % These are then plotted and compared to the CNN-LSTM model with the
    % same prediction sceeme

    % ts should be on log-scale
    % preds_cnn shold be a series of one-steps from CNN-LSTM model using
    % observations to predict the nex day. 


    sarima = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    gandalf = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    gandalf.Variance = garchmod;

    %[sarima_1, ~, logL_without] = estimate(mod, ts_train, 'Display','off');

    preds_sarima = [];
    mse_sarima = [];
    preds_gandalf = [];
    mse_gandalf = [];
  
    train_data = ts(endpoint-len_train+1:endpoint);
    for i = 1:days_ahead
        fitted_sarima = estimate(sarima, train_data, 'Display','off');
        fitted_gandalf= estimate(gandalf, train_data, 'Display','off');
        [preds_sarima(end+1), mse_sarima(end+1)] = forecast(fitted_sarima, 1, train_data);
        [preds_gandalf(end+1), mse_gandalf(end+1)] = forecast(fitted_gandalf, 1, train_data);
        train_data = [train_data; ts(endpoint+i)]; % add next observation to training data
    end
    %mse_cnn = mse_cnn_lstm(ts, preds_cnn, endpoint, len_train, true);

    % create 95% intervals
    upper_sarima = preds_sarima + 1.96*sqrt(mse_sarima);
    lower_sarima = preds_sarima - 1.96*sqrt(mse_sarima);
    upper_gandalf = preds_gandalf + 1.96*sqrt(mse_gandalf);
    lower_gandalf =  preds_gandalf - 1.96*sqrt(mse_gandalf);
    %upper_cnn = preds_cnn + 1.96*round(sqrt(mse_cnn));
    %lower_cnn = preds_cnn - 1.96*round(sqrt(mse_cnn));

    % convert to normal scale where needed
    ts = floor(exp(ts));
    test_data = ts(endpoint+1: endpoint + days_ahead);
    preds_sarima = floor(exp(preds_sarima));preds_gandalf = floor(exp(preds_gandalf));
    upper_sarima = floor(exp(upper_sarima));lower_sarima = floor(exp(lower_sarima));
    upper_gandalf = floor(exp(upper_gandalf));lower_gandalf = floor(exp(lower_gandalf));

    % calculate RRMSE and MAPE
    RRMSE_sarima = sqrt(mean((test_data - preds_sarima.').^2))/mean(test_data)*100; 
    MAPE_sarima = mean(abs(test_data - preds_sarima.')./abs(test_data))*100;
    RRMSE_gandalf = sqrt(mean((test_data - preds_gandalf.').^2))/mean(test_data)*100; 
    MAPE_gandalf = mean(abs(test_data - preds_gandalf.')./abs(test_data))*100;
    RRMSE_cnn = sqrt(mean((test_data - preds_cnn.').^2))/mean(test_data)*100; 
    MAPE_cnn = mean(abs(test_data - preds_cnn.')./abs(test_data))*100;

    % set dates
    if is_global
        dates_train = index_to_date_global(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_global(endpoint+1:endpoint+days_ahead);
    else
        dates_train = index_to_date_norway(endpoint-plot_length+1:endpoint);
        dates_test = index_to_date_norway(endpoint+1:endpoint+days_ahead);
    end
    

    % plotting
    figure
    set(gca,'FontSize',24)
    hold on

    data = plot(dates_train, ts(endpoint-plot_length+1:endpoint),'Color',[0.25, 0.25, 0.25]);
    obs = plot(dates_test,test_data, 'Color', [1, 0, 0],'LineWidth',3);
    predictions_sarima = plot(dates_test,preds_sarima, 'Color', [0.4940 0.1840 0.5560], 'LineWidth',2);
    u_sarima = plot(dates_test,upper_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    l_sarima = plot(dates_test,lower_sarima, '--','Color', [0.4940 0.1840 0.5560], 'LineWidth',1);
    predictions_gandalf = plot(dates_test,preds_gandalf, 'Color', [.2, .9, .5], 'LineWidth',2);
    u_gandalf = plot(dates_test,upper_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1);
    l_gandalf = plot(dates_test,lower_gandalf, '--', 'Color', [.2, .9, .5], 'LineWidth',1); 
    predictions_cnn = plot(dates_test,preds_cnn, 'Color', [0 0.4470 0.7410], 'LineWidth',2);
    %u_cnn = plot(dates_test,upper_cnn, '--', 'Color', [0 0.4470 0.7410], 'LineWidth',1);
    %l_cnn = plot(dates_test,lower_cnn, '--', 'Color', [0 0.4470 0.7410], 'LineWidth',1); 

    gtext([ ...
        '\color[rgb]{' sprintf('%f,%f,%f', [0.4940 0.1840 0.5560] ) '} SARIMA model: RRMSE = ', num2str(round(RRMSE_sarima, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_sarima, 2)), '%',newline, ...
        '\color[rgb]{' sprintf('%f,%f,%f', [.2, .9, .5]) '} Gandalf model: RRMSE = ', num2str(round(RRMSE_gandalf, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_gandalf, 2)), '%', newline, ...
        '\color[rgb]{' sprintf('%f,%f,%f', [0 0.4470 0.7410]) '} CNN-LSTM model: RRMSE = ', num2str(round(RRMSE_cnn, 2)), '%', ...
        ', MAPE = ', num2str(round(MAPE_cnn, 2)), '%',
        ], 'Interpreter', 'tex','FontSize', 30);

    legend([data, obs, predictions_sarima, u_sarima, predictions_gandalf, u_gandalf, predictions_cnn],...
        'Training data', 'Test data', 'Forecast SARIMA','95% interval SARIMA', ...
        'Forecast Gandalf','95% interval Gandalf', 'Forecast CNN-LSTM',  'NorthWest','FontSize', 30) % '95% interval CNN-LSTM',
    ylabel('New cases','FontSize', 30) 
    xlabel('Date','FontSize', 30) 
    if is_global
        title(['Forecasts of Global data from ', datestr(index_to_date_global(endpoint+1)), ...
            ' using only observed values to predict each ensuing day'],'FontSize', 30)
    else
        title(['Forecasts of Norwegian data from ', datestr(index_to_date_norway(endpoint+1)), ...
            ' using only observed values to predict each ensuing day'],'FontSize', 30)
    end
    set(gcf,'color','w')
    set(gca,'FontSize',20)
    ax = gca;
    
    if is_global
        ax.YAxis.Exponent = 3;
    else
        ax.YAxis.Exponent = 0;
    end
    hold off
end

function mse = mse_cnn_lstm(ts, preds_cnn, endpoint, len_train, use_observed)
    % simulates one step at a time from gandalf model to see how good the
    % prediction of the cnn-lstm model is if the underlying time series was
    % the gandalg model

    % ts should be on log scale
    days_ahead = length(preds_cnn);
    mod = arima('Constant',0,'D',1,'Seasonality',7,'MALags',1,'SMALags',7);
    garchmod = garch('Constant',0.001,'GARCHLags',1, 'ARCHLags',1);
    mod.Variance = garchmod;
    mse = [];
    if use_observed
        log_preds = log(max(preds_cnn, 0.1)); % transform to log-scale to use with gandalf model
        train_data = ts(endpoint-len_train+1:endpoint); % have to use predictions as initial observations for simulation??
        for i = 1:days_ahead
            gandalf_mod = estimate(mod, train_data, 'Display','off');
            sim = floor(exp(simulate(gandalf_mod, 1, 'NumPaths', 1000000, 'Y0', train_data)));
            mse(end+1) = mean((sim - preds_cnn(i)).^2);
            train_data = [train_data;log_preds(i)]; % add newest prediction to the reain data
        end
    else % do everything all at once???
        gandalf_mod = estimate(mod, ts(endpoint-len_train+1:endpoint), 'Display','off');
        sim = floor(exp(simulate(gandalf_mod, days_ahead, 'NumPaths', 1000000, 'Y0', ts(endpoint-len_train+1:endpoint))));
        for i = 1:days_ahead
            mse(end+1) = mean((sim(i,:) - preds_cnn(i)).^2);
        end
    end
end

function plot_norway_and_global_time_series_and_transform(ts, ts_global, include_trans)
    % This function was used to plot both time series and their respective 
    % log and difference transofrmations. 
    ts = floor(exp(ts));
    ts_global = floor(exp(ts_global));

    dates_norway = index_to_date_norway(1:length(ts));
    dates_global = index_to_date_global(1:length(ts_global));

    if include_trans
        figure
        subplot(3,2,1)
        plot_norway = plot(dates_norway, ts, 'Col', '#2eff8c');
        title('New Cases in Norway')
        ylabel('New cases')
        xlabel('Date')
        ax = gca;
        ax.YAxis.Exponent = 0;
        set(gca,'FontSize',24)
        subplot(3,2,2)
        plot_global = plot(dates_global, ts_global, 'Col', 'Magenta');
        title('Global New Cases')
        ylabel('New cases')
        xlabel('Date')
        set(gcf,'color','w')
        ax = gca;
        ax.YAxis.Exponent = 3;
        set(gca,'FontSize',24)

        subplot(3,2,3)
        plot_norway = plot(dates_norway, log(max(ts, 0.1)), 'Col', '#2eff8c');
        title('New Cases in Norway')
        ylabel('New cases')
        xlabel('Date')
        ax = gca;
        ax.YAxis.Exponent = 0;
        set(gca,'FontSize',24)

        subplot(3,2,4)
        plot_global = plot(dates_global, log(max(ts_global, 0.1)), 'Col', 'Magenta');
        title('Global New Cases')
        ylabel('New cases')
        xlabel('Date')
        set(gcf,'color','w')
        ax = gca;
        ax.YAxis.Exponent = 0;
        set(gca,'FontSize',24)


        % apply differencing on top of log transform:
        ts_trans = diff(diff(log(max(ts, 0.1)), 1), 7);
        ts_trans_global = diff(diff(log(max(ts_global , 0.1)), 1), 7);
        subplot(3,2,5)
        plot_norway = plot(dates_norway(9:end), ts_trans, 'Col', '#2eff8c'); % Note that values of the first eight days are removed!
        title('New Cases in Norway')
        ylabel('New cases')
        xlabel('Date')
        ax = gca;
        ax.YAxis.Exponent = 0;
        set(gca,'FontSize',24)
        subplot(3,2,6)
        plot_global = plot(dates_global(9:end), ts_trans_global, 'Col', 'Magenta');
        title('Global New Cases')
        ylabel('New cases')
        xlabel('Date')
        ax = gca;
        ax.YAxis.Exponent = 0;
        set(gcf,'color','w')
        set(gca,'FontSize',24)

    else
        figure
        subplot(2,1,1)
        plot_norway = plot(dates_norway, ts, 'Col', '#2eff8c');
        title('New Cases in Norway')
        ylabel('New cases')
        xlabel('Date')
        ax = gca;
        ax.YAxis.Exponent = 0;
        set(gca,'FontSize',24)
        subplot(2,1,2)
        plot_global = plot(dates_global, ts_global, 'Col', 'Magenta');
        title('Global New Cases')
        ylabel('New cases')
        xlabel('Date')
        set(gcf,'color','w')
        ax = gca;
        ax.YAxis.Exponent = 3;
        set(gca,'FontSize',24)

    end

    

end

function date = index_to_date_norway(index)
    % get value in date format from index
    % index one is February 21th 2020 for Norwegian data.
    t0 =  datetime(2020,2,21);
    date = t0 + days(index-1);
end

function date = index_to_date_global(index)
    % get value in date format from index
    % index one is January 4th 2020 for Global data.
    t0 =  datetime(2020,1,4);
    date = t0 + days(index-1);
end



