# Preprocess global
df = read.csv("WHO-COVID-19-global-data.csv")
df = df[, c(1, 2, 5)]
colnames(df) = c("Date","Country", "New_cases")
# Cut-off at February 20th 2022
df$Date = as.Date(df$Date , format = "%Y-%m-%d")
last_date = as.Date("2022-02-20", format = "%Y-%m-%d")
df$Date_diff = last_date - df$Date
df_ = df[df$Date_diff >= 0,]

new_cases_one_country = df_[df_$Country == "AF",]
worldwide_aggregated = new_cases_one_country[
  !is.na(new_cases_one_country$Country),3]

countries_list = unique(df[df$Country!= "AF",]$Country)
countries_list = countries_list[!is.na(countries_list)]

for (country in countries_list){
  new_cases_one_country = df_[df_$Country == country,]
  worldwide_aggregated = worldwide_aggregated + new_cases_one_country[
    !is.na(new_cases_one_country$Country),3]
}
worldwide_aggregated[-1]
write.csv(worldwide_aggregated[-1],"new_cases_global.csv", 
          row.names = FALSE)

# Preprocess Norway
df = read.csv("antall-meldte-covid-19-t.csv", sep = ";")
df = df[, c(1, 3)]
colnames(df) = c("Date", "New_cases")
# Cut-off at February 20th 2022
df$Date = as.Date(df$Date , format = "%d.%m.%Y")
last_date = as.Date("2022-02-20", format = "%Y-%m-%d")
df$Date_diff = last_date - df$Date
df_ = df[df$Date_diff >= 0,]
write.csv(df$New_cases,"new_cases_Norway.csv", row.names = FALSE)

